/****************************************************************************/
/* T  vF SD J[hhCo												*/
/*   F SDJ[hSCIgpđ삷hCo							*/
/*           SD J[hƂĕI I/O ȂB						*/
/*           ̂ CSD ǂݍ݃J[hTCYAubNTCYȂǕ	*/
/*          IȏŕێB										*/
/* 쐬F 2004.10.09														*/
/* XVF 2013.12.26														*/
/* Copyright    resove														*/
/****************************************************************************/
#include <stdio.h>
#include "DrvSdDmaSciItu.h"
#include "DrvSdCard.h"
#include "DrvSdRegister.h"
#include "DrvErrCode.h"

#include "DebugFunc.h"
#include "TraceOut.h"

/****************************************************************************/
/* Ŏgp萔														*/
/****************************************************************************/

#define SD_DRV_VERSION				( 0x0002 )					/* o[W */
#define SD_DRV_TYPE					"AKI-H8 DMA."				/* ^Cv		*/

#define CMD_LEN						(6)							/* R}h̒ */

/* SD R}h̒` */
#define CMD_GO_IDLE_STATE			(0)							/* Zbg */
#define CMD_SEND_OP_COND			(1)							/* vZXN */
#define CMD_SEND_CSD				(9)							/* CSD 擾 */
#define CMD_READ_SINGLE_BLOCK		(17)						/* READ  */
#define CMD_WRITE_BLOCK				(24)						/* WRITE  */
#define CMD_SET_BLOCKLEN			(16)						/* ubNTCYύX  */

#define DATA_TOKEN					(0xfe)						/* f[^ubÑg[N  */

/* SD response ̒`	*/
/* R1 response	*/
#define	RESPONSE_R1_MASK			(0x80)						/* R1 response ̃}XNrbg */
#define	RESPONSE_R1_IDLE			(0x01)						/* R1 response  IDLE state */

/* DATA Status response */
#define RESPONSE_DATA_MASK			(0x11)						/* DATA Response xxx1 sss1 */
#define RESPONSE_DATA_STATUS		(0x01)						/* DATA Response xxx0 sss1 Xe[^X̃CWP[^*/
#define RESPONSE_DATA_ST_MASK		(0x0e|RESPONSE_DATA_MASK)	/* DATA Response xxx1 1111 f[^X|X̃CWP[^ƃXe[^X*/
#define RESPONSE_DATA_ST_ACCEPT		(0x04|RESPONSE_DATA_STATUS)	/* DATA Response xxx0 0101 Accepted */
#define RESPONSE_DATA_ST_CRC_ERR	(0x0a|RESPONSE_DATA_STATUS)	/* DATA Response xxx0 1011 Rejected due to a CRC error */
#define RESPONSE_DATA_ST_WRITE_ERR	(0x0c|RESPONSE_DATA_STATUS)	/* DATA Response xxx0 1101 Rejected due to a Write error */

/* ^CAEg */
#define SD_RESET_TIME				( 1000UL )	/* Zbg̃^CAEg(1b)	*/
#define SD_RESET_COUNT				( SD_INITIAL_SYNC_RATE / 8UL )	/* Zbg̃^CAEgJEg	*/
#define SD_INITIALISE_COUNT			( SD_INITIALISE_TIME/SD_INITIALISE_INTERVAL )	/* ̃^CAEgJEg	*/
#define SD_INITIALISE_TIME			( 1000 )	/* ̃^CAEg(1b)	*/
#define SD_INITIALISE_INTERVAL		( 10 )		/* ̊Ԋu(10ms)		*/
#define SD_WRITE_RESPONSE_COUNT		(unsigned short)( SD_WRITE_RESPONSE_TIME/SD_WRITE_RESPONSE_INTERVAL )	/* Write ̃^CAEgJEg	*/
#define SD_WRITE_RESPONSE_TIME		( 500 )		/* Write ̃^CAEg	*/
#define SD_WRITE_RESPONSE_INTERVAL	( 0.064 )	/* Write ̃X|X҂Ԋu(ʐM[gSD_WAIT_WRITE_BUSY_LENɂvZ)	*/
#define SD_WAIT_WRITE_BUSY_LEN		( 16 )		/* write  BUSY ҂Mf[^ 8 oCg */
#define SD_WAIT_CMD_RESPONSE		( 8UL )		/* R}hX|X҂(8 f[^Mj*/
#define SD_WAIT_DATA_RESPONSE		( 8 )		/* f[^X|X̃ftHg҂(8 f[^Mj*/
#define SD_WAIT_REGISTER_TOKEN		( 8UL )		/* WX^̃g[N҂(8 f[^Mj*/

/* GetR1ResponseData() ̖߂l */
/* X|XG[̓rbgʒuɒĕԂ */
#define SD_ERR_IN_IDLE_STATE		( 0x0001 )	/* 0x01 */
#define SD_ERR_ERASE_RESET			( 0x0002 )	/* 0x02 */
#define SD_ERR_ILLEGAL_COMMAND		( 0x0003 )	/* 0x04 */
#define SD_ERR_COM_CRC_ERROR		( 0x0004 )	/* 0x08 */
#define SD_ERR_ERASE_SEQ_ERROR		( 0x0005 )	/* 0x10 */
#define SD_ERR_ADDRESS_ERROR		( 0x0006 )	/* 0x20 */
#define SD_ERR_PARAMETER_ERROR		( 0x0007 )	/* 0x40 */

/* GetR1ResponseData() ̃X|XG[ȊÕG[ */
#define SD_ERR_DATA_RECEIVE_TIMEOUT	( 0x0008 )	/* f[^M^CAEg	*/
#define SD_ERR_RESPONSE_TIMEOUT		( 0x0009 )	/* X|XM^CAEg	*/
#define SD_ERR_TOKEN_RECEIVE_TIMEOUT ( 0x000a )	/* g[NM^CAEg */


/* read ̎s */
typedef enum e_read_stage
{
	RS_NONE = 0,				/* s						*/
	RS_START,					/* ǂݎJn					*/
	RS_WAIT_CMD_SEND,			/* R}hM҂		*/
	RS_WAIT_RESPONSE,			/* R}hX|X҂		*/
	RS_WAIT_TOKEN,				/* f[^g[N҂			*/
	RS_WAIT_PRE_THROW,			/* ŏ̓ǂݎ̂Ċ҂		*/
	RS_WAIT_READ,				/* ǂݎ芮҂			*/
	RS_WAIT_POST_THROW,			/* ̓ǂݎ̂Ċ҂		*/
	RS_WAIT_CRC,				/* f[^ubNŌCRC҂*/
	RS_COMPLETE					/* I							*/
} E_READ_STAGE;

/* write ̎s */
typedef enum e_write_stage
{
	WS_NONE = 0,				/* s						*/
	WS_START,					/* ݊Jn					*/
	WS_WAIT_CMD_SEND,			/* R}hM҂		*/
	WS_WAIT_RESPONSE,			/* R}hX|X҂		*/
	WS_WAIT_WRITE,				/* ݊҂			*/
	WS_WAIT_DATA_RESPONSE,		/* f[^X|XM҂	*/
	WS_WAIT_BUSY,				/* BUSY҂				*/
	WS_RELEASE_BUSY,			/* BUSY					*/
	WS_COMPLETE					/* I							*/
} E_WRITE_STAGE;

/****************************************************************************/
/* ϐ																	*/
/****************************************************************************/

static T_SD_CSD csd;							/* CSD i[̈ */
static unsigned long cardSize;					/* J[hTCY			*/
static unsigned short blockSize;				/* ubNTCY		*/

static unsigned long dataResponseTimeout;		/* f[^X|X^CAEgoCg */
static unsigned long syncRate;					/* ʐM[g					*/

/* read ̏ԊǗf[^ubN */
static struct s_read_status
{
	E_READ_STAGE stage;							/* read ̃Xe[W		*/
	unsigned short result;						/* s				*/
	unsigned long addr;							/* ǂݎAhX		*/
	char *buff;									/* i[̈				*/
	unsigned short bufLen;						/* Kvȃf[^		*/
	unsigned short throwLen;					/* ǂݎ̂Ăf[^	*/
	unsigned long timeOutLen;		/* R}hX|Xƃg[N^CAEg	*/
	unsigned long responseCompLen;	/* R}hX|XM	*/
	unsigned short respBlockLen;	/* R}hX|XMubN	*/
	unsigned short completeLen;					/* f[^MTCY	*/
} readStatus =
{
	RS_NONE,									/* read ̃Xe[W		*/
	SD_OK,										/* s				*/
	0L,											/* ǂݎAhX		*/
	NULL,										/* i[̈				*/
	0,											/* Kvȃf[^		*/
	0,											/* ǂݎ̂Ăf[^	*/
	0L,											/* R}hX|Xƃg[N^CAEg	*/
	0L,											/* R}hX|XM	*/
	0,											/* R}hX|XMubN	*/
	0											/* f[^MTCY	*/
};
/* write ̏ԊǗf[^ubN */
static struct s_write_status
{
	E_WRITE_STAGE stage;						/* write ̃Xe[W		*/
	unsigned short result;						/* s				*/
	unsigned short fillFlag;					/* f[^Ŗ߂tO	*/
	char fillData;								/* f[^Ŗ߂ꍇ̃f[^ */
	unsigned long addr;							/* AhX				*/
	char *buff;									/* f[^̈			*/
	unsigned short busyTime;					/* busy ^CAEgJEg*/
	unsigned short busySearchPoint;				/* obt@ busy g[Nʒu */
	unsigned short busySearchLen;				/* obt@ busy g[N͈ */
} writeStatus =
{
	WS_NONE,									/* write ̃Xe[W		*/
	SD_OK,										/* s				*/
	0,											/* f[^Ŗ߂tO	*/
	0,											/* f[^Ŗ߂ꍇ̃f[^ */
	0UL,										/* AhX				*/
	NULL,										/* f[^̈			*/
	0,											/* Mobt@		*/
	0,											/* obt@ busy g[Nʒu */
	0,											/* obt@ busy g[N͈ */
};

static char transBuff[SD_WAIT_WRITE_BUSY_LEN];/* Mobt@		*/

/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
static unsigned short ResetCard( void );			/* ZbgAvZXN */
static unsigned short waitForReply( unsigned char mask,
									unsigned char comp,
									unsigned long timeout );	/* X|XԂ̂҂ */
static unsigned short publishCmd( char cmd, unsigned long addr );	/* R}hs	*/
static unsigned short kickCmd( char cmd, unsigned long addr );	/* R}hs(񓯊)	*/
static unsigned short ReadAndCheckCsd( void );		/* CSD ̃[hƃ`FbN	*/
static unsigned short CheckCsd( void );				/* CSD ̓e`FbN	*/
static unsigned long CalcReadTimeout( void );		/* f[^X|X^CAEgvZ */
static unsigned long CalcRate( void );				/* ʐM[ǧvZƍXV	*/
static unsigned short writeBlock( unsigned long address,
								 char * writeData,
								 unsigned short fill );	/* write  fill ̋ʊ֐ */
static unsigned short GetR1ResponseData( char cmd,
						unsigned long parm,
						unsigned short len,
						char * regBuff,
						unsigned long timeOut);		/* WX^ǂݍݔėp֐ */

static unsigned short readSdCheck( void );			/* 񓯊 read ̃p[^`FbN */
static unsigned short writeSdCheck( void );			/* 񓯊 write ̃p[^`FbN */
static void readSdControl( void );
static void writeSdControl( void );
static unsigned short waitResource( void );			/* read/write ̃\[X҂	*/

static unsigned short readResponseKick( void );		/* X|XAg[NM̋N */

static unsigned short BitToNum(unsigned short bit);	/* rbgʒuԂ */
static unsigned long Pow(unsigned long base, unsigned long n);	/* ׂvZ */
static unsigned long CalcBlockSize( void );					/* ubNTCYvZ */
static unsigned long CalcCardSize( void );					/* J[hTCYvZ */
static unsigned short changeBlockSize( void );				/* ubNTCYύX	*/

/****************************************************************************/
/* T  v																	*/
/*        hCo													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        @gpn[hEFȀȂ							*/
/*          n[h́A											*/
/*           ESCI															*/
/*           E|[g														*/
/*           E^C}														*/
/*        AJ[h̃ZbgvZXN							*/
/*        BCSD ̓ǂݎ聕`FbN										*/
/****************************************************************************/
unsigned short InitSdCard( void )
{
	unsigned short retCode;

	blockSize = 0;
	cardSize = 0UL;

	retCode = waitResource( );							/* O̎sI܂ő҂ */

	if( retCode == SD_OK )
	{

		readStatus.stage = RS_NONE;						/* read ̃V[PXf[^	*/
		readStatus.result = SD_OK;						
		writeStatus.stage = WS_NONE;					/* write ̃V[PXf[^	*/
		writeStatus.result = SD_OK;						

		InitSdPort();									/* SD֘Ã|[g */
		InitSdTrans();								 	/* SD VA|[g	 */
		InitSdWait();									/* ^C} */
		retCode = ResetCard( );							/* ZbgvZX	*/
		if( retCode == SD_OK )
		{
			retCode = ReadAndCheckCsd( );				/* CSD ǂݎ聕`FbN */
			if( retCode == SD_OK )
			{
				retCode = changeBlockSize( );			/* ubNTCYύX	*/
				if( retCode != SD_OK )
				{
				 retCode |= SD_ERR_INIT;
				 }
			}
		}

	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[hZbg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         gpn[hEFȀȂ							*/
/*         n[h́A												*/
/*         ESCI															*/
/*         E|[g															*/
/*         E^C}															*/
/*         SD J[hɏR}h𑗂ăX|X҂				*/
/****************************************************************************/
unsigned short ResetCard( void )
{
	unsigned int i;
	unsigned short answer = 0;
	unsigned short retCode = SD_ERR_INIT_RESET_TIMEOUT;

	SetSdOnChipsel( FALSE );						/* CS OFF */


	SendSdRepeat( (char)0xff, 10 );

	/* ZbgR}h */
	SetSdOnChipsel( TRUE );							/* CS ON */
	publishCmd( CMD_GO_IDLE_STATE, 0L );			/* RESET			*/

	answer = waitForReply( 0x0ff, RESPONSE_R1_IDLE, SD_RESET_COUNT );	/* idle state ɂȂ܂ő҂ */
	SetSdOnChipsel( FALSE );						/* CS OFF */

	/* vZXN */
	if( answer == RESPONSE_R1_IDLE )
	{
		retCode = SD_ERR_INIT_INIT_TIMEOUT;
		for( i = 0; i < SD_INITIALISE_COUNT; ++i )
		{
			SdWaitTimer( SD_INITIALISE_INTERVAL );	/* ҂			*/
			SendSdOne( '\xff' );

			SetSdOnChipsel( TRUE );					/* CS ON */
			publishCmd( CMD_SEND_OP_COND, 0L );		/* vZXN R}h	*/
			answer = waitForReply( 0xff, 0x00, SD_WAIT_CMD_RESPONSE );	/* idle state ̂҂ */
			SetSdOnChipsel( FALSE );				/* CS OFF */
			if( answer == 0x00 )
			{
				retCode = SD_OK;
				break;
			}
		}
	}
	SetSdOnChipsel( FALSE );						/* CS OFF */

	SendSdOne( '\xff' );

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        Iȏ݂Ȃ										*/
/* p[^																*/
/*        addrFރJ[h̃AhX									*/
/*        buffFރf[^												*/
/*        len Fޒ												*/
/* ߂l																	*/
/*        F SD_OK														*/
/*   																	*/
/*        w肳ꂽf[^J[hɏށB								*/
/*        ݂̓ubNPʂłȂȂBJnʒuAIʒu	*/
/*       ubN̋EƍȂꍇ̓G[ƂȂB						*/
/****************************************************************************/
unsigned short WriteSdPhysical( unsigned long addr, char * buff, unsigned short len )
{
	unsigned short retCode = SD_ERR_DRV_INITIAL;

	if( ( blockSize != 0 ) && ( cardSize != 0UL ) )
	{
		retCode = SD_OK;

		/* AhX`FbN */
		if( ( addr % (unsigned long)blockSize) != 0UL )
		{
			retCode = SD_ERR_REQ_ADDRESS;
		}
		else if( len != blockSize )
		{
			retCode = SD_ERR_REQ_LEN;
		}
		else if( (addr + (unsigned long)len) > cardSize)
		{
			retCode = SD_ERR_REQ_ADDRESS;
		}
		else
		{
			retCode = writeBlock( addr, buff, FALSE );
		}
	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        Iȓǂݎ̊Jn											*/
/* p[^																*/
/*        addrFǂݎJ[h̃AhX									*/
/*        buffFǂݎf[^												*/
/*        len Fǂݎ钷												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        read ̊JnB														*/
/****************************************************************************/
unsigned short ReadSdPhysical( unsigned long addr, char * buff, unsigned short len )
{
	readStatus.result = waitResource( );			/* O̎sI܂ő҂ */

	if( readStatus.result != SD_OK )
	{
		readStatus.stage = RS_COMPLETE;				/* G[ŏI	*/
	}
	else
	{

		readStatus.stage = RS_START;
		readStatus.result = SD_OK;
		readStatus.addr = addr;
		readStatus.buff = buff;
		readStatus.bufLen = len;
		readStatus.throwLen = 0;
		readStatus.completeLen = 0;

		readSdControl();
	}
	return readStatus.result;

}

/****************************************************************************/
/* T  v																	*/
/*        IȓǂݎȂ										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ǂݎ̗v readStatue Ɋi[B܂Aʂ󋵂		*/
/*       readStatus Ɋi[B											*/
/*        ǂݎ̊JnAhX̓ubN̋EƍĂȂĂ悢B	*/
/*       AubNTCY𒴂vubN̋E܂v	*/
/*       ͎󂯕tȂB													*/
/*        荞݂œ삷@\Nۂɂ͐ɃXe[WύXB	*/
/*       ֐IOɊ荞݂\邽߁B					*/
/****************************************************************************/
void readSdControl( void )
{
	unsigned short remain;								/* ǂݎ̂Ăf[^		*/
	unsigned long blockAddr;							/* ubN̐擪AhX	*/
	unsigned short response;							/* R}hX|X		*/
	unsigned short dataPoint;							/* X|X҂̍ۂɎMf[^ʒu */
	unsigned short i;									/* [ṽCfbNX		*/
	unsigned short tokenSearchPoint = 0;				/* [ṽCfbNX		*/
	char *buffSrc;										/* Rs[̃|C^		*/
	char *buffDist;										/* Rs[̃|C^		*/

	switch( readStatus.stage )
	{
		case RS_START:
			readStatus.result = readSdCheck(  );			/* ṽ`FbN */
			if( readStatus.result != SD_OK )
			{
				readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}

			/* ubN̐擪AhXZo */
			blockAddr = readStatus.addr / (unsigned long)blockSize;
			blockAddr *= (unsigned long)blockSize;			/* ubN̐擪ʒu */
			readStatus.throwLen
				= (unsigned short)(readStatus.addr % (unsigned long)blockSize);	/* ubN̈ʒu */
			readStatus.timeOutLen = SD_WAIT_CMD_RESPONSE + dataResponseTimeout;
			readStatus.responseCompLen = 0L;
			readStatus.stage = RS_WAIT_CMD_SEND;
			SetSdOnChipsel( TRUE );							/* CS ON */
			if( kickCmd( CMD_READ_SINGLE_BLOCK, blockAddr ) == FALSE )	/* READ CMD */
			{
				readStatus.result = SD_ERR_CMD_TIMEOUT;
				readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
			}
			break;

		case RS_WAIT_CMD_SEND:
			/* R}hƃf[^g[NM		*/
			/* f[^̎Mobt@𗘗p	*/
			readStatus.stage = RS_WAIT_RESPONSE;
			readStatus.result = readResponseKick( );		/* MN */
			if( readStatus.result != SD_OK )
			{
				readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
			}
			break;

		case RS_WAIT_RESPONSE:
			/* R}hX|XT */
			response = SD_DRV_ERR_VAL;
			buffSrc = &readStatus.buff[0];
			for( i = 0; i < readStatus.respBlockLen; i++, buffSrc++ )
			{
				if( ( *buffSrc & 0x80 ) == 0x00 )
				{
					/* X|X */
					response = (unsigned short)*buffSrc;
					buffSrc++;
					i++;
					break;
				}
			}
			if( response == SD_DRV_ERR_VAL )
			{
				readStatus.responseCompLen += (unsigned long)readStatus.respBlockLen;
				if( readStatus.responseCompLen < SD_WAIT_CMD_RESPONSE ) {
					readStatus.stage = RS_WAIT_RESPONSE;		/* M */
					readStatus.result = readResponseKick( );
					if( readStatus.result != SD_OK )
					{
						readStatus.stage = RS_COMPLETE;		/* G[Ȃ̂Œf */
					}
					break;
				}
				else {
					/* X|X^CAEg */
					readStatus.result = SD_ERR_READ|SD_ERR_RESPONSE_TIMEOUT;
					readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
					break;
				}
			}
			else if( response != 0x00 )
			{
				/* G[X|X */
				readStatus.result = BitToNum((unsigned short)response)+1;
				readStatus.result |= SD_ERR_READ;
				readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}
			else
			{
				/* 탌X|X		*/
				tokenSearchPoint = i;
				readStatus.stage = RS_WAIT_TOKEN;
				/* break ̂܂܃g[No */
			}
	
		case RS_WAIT_TOKEN:
			/* f[^g[NT */
			dataPoint = 0xffff;
			buffSrc = &readStatus.buff[tokenSearchPoint];
			for( i = tokenSearchPoint; i < readStatus.respBlockLen; i++, buffSrc++ )
			{
				if( ( *buffSrc & 0xff ) == DATA_TOKEN )
				{
					/* g[N */
					dataPoint = i+1;		/* f[^ */
					break;
				}
			}

			if( dataPoint == 0xffff )
			{
				readStatus.responseCompLen += (unsigned long)readStatus.respBlockLen;
				if( readStatus.responseCompLen < readStatus.timeOutLen )
				{
					readStatus.stage = RS_WAIT_TOKEN;		/* M */
					readStatus.result = readResponseKick( );
					if( readStatus.result != SD_OK )
					{
						readStatus.stage = RS_COMPLETE;		/* G[Ȃ̂Œf */
					}
					break;
				}
				else
				{
					/* g[N^CAEg */
					readStatus.result = SD_ERR_READ_TOKEN_RCV_TIMEOUT;
					readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
					break;
				}
			}

			readStatus.stage = RS_WAIT_PRE_THROW;
			/* ǂݎ̂Ăf[^ꍇ */
			if( (readStatus.respBlockLen - dataPoint) <  readStatus.throwLen )
			{
				readStatus.throwLen -= readStatus.respBlockLen - dataPoint;
				if( RepeatSdKick( '\xff', readStatus.throwLen ) == FALSE )	/* ǂݎ̂ */
				{
					readStatus.result = SD_ERR_CMD_TIMEOUT;
					readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
				}
				break;
			}
			else
			{
				/* Kvȃf[^Rs[ */
				buffSrc  = &readStatus.buff[dataPoint + readStatus.throwLen];
				buffDist = &readStatus.buff[0];
				for( i = 0; i < (readStatus.respBlockLen - dataPoint) - readStatus.throwLen; i++ )
				{
					*buffDist = *buffSrc;
					buffSrc++;
					buffDist++;
				}
				readStatus.completeLen = i;		/* f[^M */
			}
			/* break ȂB ǂݎ̂ĂȂꍇ͂ɓǂ݂ɍs */

		case RS_WAIT_PRE_THROW:
			/* f[^̓ǂݎ */
			readStatus.stage = RS_WAIT_READ;
			if( readStatus.bufLen > readStatus.completeLen )
			{
				if( RecvSdKick( readStatus.buff + readStatus.completeLen,
							 '\xff',
						 (unsigned short)(readStatus.bufLen - readStatus.completeLen)) == FALSE )	/* ǂݎ */
				{
					readStatus.result = SD_ERR_CMD_TIMEOUT;
					readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
				}
				break;
			}
			/* ǂݎf[^Ȃꍇ break Ȃ */

		case RS_WAIT_READ:
			readStatus.completeLen = readStatus.bufLen;	/* f[^ǂݎ芮 */
			remain = blockSize - readStatus.throwLen - readStatus.bufLen;
			readStatus.stage = RS_WAIT_POST_THROW;	/* ̓ǂݎ̂đ҂ */
			if( remain != 0 )
			{
				/* f[^ǂݎ̂Ă */
				if( RepeatSdKick( '\xff', remain ) == FALSE )	/* ǂݎ̂ */
				{
					readStatus.result = SD_ERR_CMD_TIMEOUT;
					readStatus.stage = RS_COMPLETE;				/* G[Ȃ̂Œf */
				}
				break;
			}
			/* break ȂB ǂݎ̂ĂȂꍇ͑ CRC  */

		case RS_WAIT_POST_THROW:
			readStatus.stage = RS_WAIT_CRC;
			SendSdOne( '\xff' );
			SendSdOne( '\xff' );						/* _~[ CRC M */
			/* 荞ݔȂ̂ break Ȃ */

		case RS_WAIT_CRC:
			SetSdOnChipsel( FALSE );					/* CS OFF */
			SendSdOne( '\xff' );
			readStatus.result = SD_OK;
			readStatus.stage = RS_COMPLETE;				/* I */
			break;

		default:
			break;
	}
}

/****************************************************************************/
/* T  v																	*/
/*        X|XAf[^g[NMN							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        R}hX|Xƃf[^g[N̎M𕪊ĂȂۂ	*/
/*       sB															*/
/****************************************************************************/
unsigned short readResponseKick( void )
{
	unsigned short res = SD_OK;

	if( (readStatus.timeOutLen - readStatus.responseCompLen ) > (unsigned long)readStatus.bufLen )
	{
		readStatus.respBlockLen = readStatus.bufLen;
	}
	else {
		readStatus.respBlockLen = (unsigned short)(readStatus.timeOutLen - readStatus.responseCompLen);
	}
	if( RecvSdKick( readStatus.buff, '\xff', readStatus.respBlockLen ) == FALSE )
	{
		res = SD_ERR_CMD_TIMEOUT;
	}

	return res;
}

/****************************************************************************/
/* T  v																	*/
/*        ǂݎv̐`FbN								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        `FbN														*/
/*   																	*/
/*        ȉ`FbNB												*/
/*        EĂ邱										*/
/*        E 0 łȂ												*/
/*        EubN𒴂Ȃ										*/
/*        EubNE܂Ȃ									*/
/*        EfBAŜ͈̔͂𒴂Ȃ								*/
/****************************************************************************/
unsigned short readSdCheck( void )
{
	unsigned short err = SD_OK;

	if( ( blockSize == 0 ) || ( cardSize == 0UL ) )
	{
		/* s */
		err = SD_ERR_DRV_INITIAL;
		
	}
	else if( readStatus.bufLen == 0 )
	{
		/*  0  */
		err = SD_ERR_REQ_LEN;
	}
	else if( (readStatus.addr + (unsigned long)readStatus.bufLen) > cardSize)
	{
		/* J[hŜ̊O𒴂v */
		err = SD_ERR_REQ_ADDRESS;
	}
	else if( readStatus.bufLen > blockSize )
	{
		/* ubNTCY𒴂v͎󂯕tȂ */
		err = SD_ERR_REQ_LEN;
	}
	else if( ((unsigned short)(readStatus.addr % (unsigned long)blockSize) + readStatus.bufLen ) > blockSize )
	{
		/* ubN̋E܂ */
		err = SD_ERR_OVER_BOARDER;
	}

	return err;
}
/****************************************************************************/
/* T  v																	*/
/*        ݗv̐`FbN								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        `FbN														*/
/*   																	*/
/*        ȉ`FbNB												*/
/*        EĂ邱										*/
/*        EubNE܂Ȃ									*/
/*        EfBAŜ͈̔͂𒴂Ȃ								*/
/****************************************************************************/
unsigned short writeSdCheck( void )
{
	unsigned short err = SD_OK;

	if( ( blockSize == 0 ) || ( cardSize == 0UL ) )
	{
		/* s */
		err = SD_ERR_DRV_INITIAL;
		
	}
	else if( (writeStatus.addr + (unsigned long)blockSize) > cardSize)
	{
		/* J[hŜ̊O𒴂v */
		err = SD_ERR_REQ_ADDRESS;
	}
	else if( (writeStatus.addr % (unsigned long)blockSize) != 0L )
	{
		/* ubN̋E܂ */
		err = SD_ERR_OVER_BOARDER;
	}
	/* else  ̏ꍇ SD_OK Ԃ */

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        Iȓǂݎ̊mF											*/
/* p[^																*/
/*        *size FǂݎꂽTCYi[̈							*/
/* ߂l																	*/
/*        SD_OKFI													*/
/*   																	*/
/*        read ̊JnB														*/
/****************************************************************************/
unsigned short ReadSdPoll( unsigned short * size )
{
	T_SD_POLL pollStatus;
	unsigned short completeSize = 0;
	unsigned short result = SD_OK;

	if( (readStatus.stage == RS_WAIT_POST_THROW ) ||
		(readStatus.stage == RS_WAIT_CRC ) )
	{
		/* ǂݎ͍ςł̂őSTCY */
		*size = readStatus.bufLen;
	}
	else if( readStatus.stage == RS_WAIT_READ )
	{
		/* ǂݎ蒆Ȃ̂œr̃TCYԂ */
		pollStatus = SdDmaPoll( &completeSize );
		if( ( pollStatus == SD_POLL_CONTINUE ) ||
			( pollStatus == SD_POLL_COMPLETE ) )
		{
			*size = completeSize + readStatus.completeLen;
		}
		else
		{
			result = SD_ERR_POLLING;
		}
	}
	else if( readStatus.stage == RS_COMPLETE )
	{
		result = readStatus.result;
		if( result == SD_OK )
		{
			/* ŏIĂ̂őSTCY */
			*size = readStatus.bufLen;
			readStatus.stage = RS_NONE;
		}
		else
		{
			/* sĂ̂ŃTCY = 0 */
			*size = 0;
			readStatus.stage = RS_NONE;
		}
	}
	else if( readStatus.stage == RS_NONE )
	{
		/* JnĂȂ */
		result = SD_ERR_POLLING;
	}
	else
	{
		/* RS_START				*/
		/* RS_WAIT_CMD_SEND		*/
		/* RS_WAIT_RESPONSE		*/
		/* RS_WAIT_PRE_THROW	*/
		
		/* ܂ǂłȂ */
		*size = 0;
	}

	return result;
}

/****************************************************************************/
/* T  v																	*/
/*        P̃ZN^P̒lŃNA								*/
/* p[^																*/
/*        addressFubNAhX											*/
/*        writeDataFރf[^											*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_WRITE_TIMEOUT   ݃^CAEg						*/
/*         SD_ERR_WRITE_CRC_ERR   ݎ CRC G[						*/
/*         SD_ERR_WRITE_PHYSICAL  ݕIȃG[					*/
/*   																	*/
/*        FillSdOneBlock()͓f[^JԂށB					*/
/****************************************************************************/
unsigned short FillSdOneBlock( unsigned long address, char writeData )
{
	return writeBlock( address, &writeData, TRUE );
}

/****************************************************************************/
/* T  v																	*/
/*        P̃ZN^ɏ											*/
/* p[^																*/
/*        address  FubNAhX										*/
/*        writeDataFރf[^											*/
/*        fill     Ff[^ fill ̏ꍇ TRUEA						*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_WRITE_TIMEOUT   ݃^CAEg						*/
/*         SD_ERR_WRITE_CRC_ERR   ݎ CRC G[						*/
/*         SD_ERR_WRITE_PHYSICAL  ݕIȃG[					*/
/*   																	*/
/*        WriteSdOneBlock()FillSdOneBlock() ŎgpB					*/
/*        Write̎菇́A													*/
/*         @R}h24𑗂												*/
/*         AR}hX|XOKH										*/
/*         B_~[TCN}												*/
/*         Cg[N𑗂													*/
/*         Df[^𑗂													*/
/*         E݃X|XOKH										*/
/*         FBUSY ҂												*/
/*              															*/
/*        f[^X|X̌`͈ȉB									*/
/*         +----+----+														*/
/*         |xxx0|sss1|  x:Dont Care.										*/
/*         +----+----+  s:Status											*/
/*              															*/
/*        0001 0001  AND ̂ 0000 0001 ƂȂĂ΃X|	*/
/*        XƂ݂ȂB														*/
/*        status ́A														*/
/*         010:Data accepted.												*/
/*         101:Data rejected due to a CRC error.							*/
/*         111:Data rejected due to a Write error.							*/
/****************************************************************************/
unsigned short writeBlock( unsigned long address, char * writeData, unsigned short fill )
{

	/* O̎sI܂ő҂ */
	writeStatus.result = waitResource( );			/* O̎sI܂ő҂ */
	if( writeStatus.result != SD_OK )
	{
		writeStatus.stage = WS_COMPLETE;
	}
	else
	{
		writeStatus.stage = WS_START;				/* write ̃Xe[W		*/
		writeStatus.result = SD_OK;					/* s				*/
		writeStatus.fillFlag = fill;				/* f[^Ŗ߂tO	*/
		writeStatus.fillData = *writeData;			/* f[^Ŗ߂ꍇ̃f[^ */
		writeStatus.addr = address;					/* AhX				*/
		writeStatus.buff = writeData;				/* f[^̈			*/
		writeStatus.busyTime = 0;					/* busy ^CAEgJEg	*/

		writeSdControl( );
	}

	return writeStatus.result;
}

/****************************************************************************/
/* T  v																	*/
/*        Iȏ݂Ȃ										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ݂̗v writeStatus Ɋi[B܂Aʂ󋵂		*/
/*       writeStatus Ɋi[B											*/
/*        荞݂œ삷@\Nۂɂ͐ɃXe[WύXB	*/
/*       ֐IOɊ荞݂\邽߁B					*/
/****************************************************************************/
void writeSdControl( void )
{
	unsigned short response;							/* R}hX|X		*/
	unsigned short i;									/* [ṽCfbNX		*/

	switch( writeStatus.stage )
	{
		case WS_START:
			writeStatus.result = writeSdCheck(  );			/* ṽ`FbN */
			if( writeStatus.result != SD_OK )
			{
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}

			/* ubN̐擪AhXZo */
			writeStatus.stage = WS_WAIT_CMD_SEND;
			SetSdOnChipsel( TRUE );								/* CS ON */
			if( kickCmd( CMD_WRITE_BLOCK, writeStatus.addr ) == FALSE )	/* write R}h*/
			{
				writeStatus.result = SD_ERR_CMD_TIMEOUT;
				writeStatus.stage = WS_COMPLETE;			/* G[Ȃ̂Œf */
			}
			break;

		case WS_WAIT_CMD_SEND:
			/* R}hX|XMJn		*/
			writeStatus.stage = WS_WAIT_RESPONSE;
			if( RecvSdKick( transBuff, '\xff', SD_WAIT_CMD_RESPONSE ) == FALSE )
			{
				writeStatus.result = SD_ERR_CMD_TIMEOUT;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
			}
			break;

		case WS_WAIT_RESPONSE:
			/* R}hX|XT */
			response = SD_DRV_ERR_VAL;
			for( i = 0; i < SD_WAIT_CMD_RESPONSE; i++ )
			{
				if( transBuff[i] == 0x00 )
				{
					/* X|X */
					response = (unsigned short)transBuff[i];
					break;
				}
			}
			if( response == SD_DRV_ERR_VAL )
			{
				/* X|X^CAEg */
				writeStatus.result = SD_ERR_WRITE|SD_ERR_RESPONSE_TIMEOUT;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}
			else if( response != 0x00 )
			{
				/* G[X|X */
				writeStatus.result = BitToNum((unsigned short)response)+1;
				writeStatus.result |= SD_ERR_WRITE;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}
			else
			{
				/* 탌X|XAg[NMJn		*/
				SendSdOne( '\xff' );				/* 8 rbg̑҂Kv */
				SendSdOne( (char)DATA_TOKEN );		/* g[NM */
			}
	
			/* f[^M */
			writeStatus.stage = WS_WAIT_WRITE;
			if( writeStatus.fillFlag != 0 )
			{
				/* fill */
				if( RepeatSdKick( writeStatus.fillData, blockSize ) == FALSE )	/* f[^̌JԂM̋N */
				{
					writeStatus.result = SD_ERR_CMD_TIMEOUT;
					writeStatus.stage = WS_COMPLETE;			/* G[Ȃ̂Œf */
				}
			}
			else
			{
				/* f[^ */
				if( SendSdKick( writeStatus.buff, blockSize ) == FALSE )	/* Af[^̑MN */
				{
					writeStatus.result = SD_ERR_CMD_TIMEOUT;
					writeStatus.stage = WS_COMPLETE;			/* G[Ȃ̂Œf */
				}
			}
			break;

		case WS_WAIT_WRITE:
			SendSdOne( '\0' );
			SendSdOne( '\0' );					/* _~[ CRC M */

			/* f[^X|XMJn */
			writeStatus.stage = WS_WAIT_DATA_RESPONSE;
			if( RecvSdKick( transBuff, '\xff', SD_WAIT_DATA_RESPONSE ) == FALSE )
			{
				writeStatus.result = SD_ERR_CMD_TIMEOUT;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
			}
			break;
		
		case WS_WAIT_DATA_RESPONSE:
			/* f[^X|XT */
			writeStatus.stage = WS_WAIT_BUSY;
			writeStatus.busyTime = 0;
			response = SD_DRV_ERR_VAL;
			for( i = 0; i < SD_WAIT_DATA_RESPONSE; i++ )
			{
				if( ( transBuff[i] & RESPONSE_DATA_MASK ) == RESPONSE_DATA_STATUS )
				{
					/* X|X */
					response = (unsigned short)transBuff[i];
					break;
				}
			}
			if( response == SD_DRV_ERR_VAL )
			{
				writeStatus.result = SD_ERR_WRITE_TIMEOUT;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}
			else if( ( response & RESPONSE_DATA_ST_MASK )
									== RESPONSE_DATA_ST_ACCEPT )	/* OK	*/
			{
				writeStatus.busySearchPoint = i+1;
				writeStatus.busySearchLen = SD_WAIT_DATA_RESPONSE;
				if( ChangeSdRate( SD_BUSY_SYNC_RATE ) == FALSE )	/* ʐM[g𗎂Ƃ */
				{
					writeStatus.result = SD_ERR_BIT_RATE;
					writeStatus.stage = WS_COMPLETE;			/* G[Ȃ̂Œf */
					break;
				}
				/* breakȂ */
			}
			else if( ( response & RESPONSE_DATA_ST_MASK )
									== RESPONSE_DATA_ST_CRC_ERR )	/* CRCG[	*/
			{
				writeStatus.result = SD_ERR_WRITE_CRC_ERR;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}
			else if( ( response & RESPONSE_DATA_ST_MASK )
								== RESPONSE_DATA_ST_WRITE_ERR )		/* write G[ */
			{
				writeStatus.result = SD_ERR_WRITE_PHYSICAL;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}
			else
			{
				writeStatus.result = SD_ERR_WRITE_TIMEOUT;
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				break;
			}
			/* 탌X|X󂯎ۂ break Ȃ */

		case WS_WAIT_BUSY:
			writeStatus.busyTime++;
			if( writeStatus.busyTime > SD_WRITE_RESPONSE_COUNT )
			{
				writeStatus.result = SD_ERR_WRITE_OTHER;		/* busy ^CAEg	*/
				writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf		*/
				ChangeSdRate( syncRate );						/* ʐM[gɖ߂(ł͖߂lȂ) */
				break;
			}
			
			for( i = writeStatus.busySearchPoint; i < writeStatus.busySearchLen; i++ )
			{
				if( (transBuff[i] & 0x0ff ) == 0x0ff )
				{
					writeStatus.stage = WS_RELEASE_BUSY;			/* busy ꂽ */
					if( ChangeSdRate( syncRate ) == FALSE )			/* ʐM[gɖ߂ */
					{
						writeStatus.result = SD_ERR_BIT_RATE;
						writeStatus.stage = WS_COMPLETE;			/* G[Ȃ̂Œf */
					}
					break;
				}
			}
			if( writeStatus.stage == WS_WAIT_BUSY )
			{
				writeStatus.busySearchPoint = 0;
				writeStatus.busySearchLen = SD_WAIT_WRITE_BUSY_LEN;
				if( RecvSdKick( transBuff, '\xff', SD_WAIT_WRITE_BUSY_LEN ) == FALSE )
				{
					writeStatus.result = SD_ERR_CMD_TIMEOUT;
					writeStatus.stage = WS_COMPLETE;				/* G[Ȃ̂Œf */
				}
				break;
			}
			/* uwriteStatus.stage = WS_RELEASE_BUSYv ̂Ƃ break Ȃ */

		case WS_RELEASE_BUSY:
			/* busy Awrite vZX */
			SetSdOnChipsel( FALSE );					/* CS OFF */
			SendSdOne( '\xff' );
			writeStatus.result = SD_OK;
			writeStatus.stage = WS_COMPLETE;				/* I */
			break;

		default:
			break;
	}
}

/****************************************************************************/
/* T  v																	*/
/*        Iȏ݂̊mF											*/
/* p[^																*/
/*        *size F݊TCYi[̈							*/
/* ߂l																	*/
/*        SD_OKFI													*/
/*   																	*/
/****************************************************************************/
unsigned short WriteSdPoll( unsigned short * size )
{
	T_SD_POLL pollStatus;
	unsigned short completeSize = 0;
	unsigned short result = SD_OK;

	if( (writeStatus.stage == WS_WAIT_DATA_RESPONSE ) ||
		(writeStatus.stage == WS_WAIT_BUSY ) ||
		(writeStatus.stage == WS_RELEASE_BUSY ) )
	{
		/* ǂݎ͍ςł̂őSTCY */
		*size = blockSize;
	}
	else if( writeStatus.stage == WS_WAIT_WRITE )
	{
		/* ǂݎ蒆Ȃ̂œr̃TCYԂ */
		pollStatus = SdDmaPoll( &completeSize );
		if( ( pollStatus == SD_POLL_CONTINUE ) ||
			( pollStatus == SD_POLL_COMPLETE ) )
		{
			*size = completeSize;
		}
		else
		{
			result = SD_ERR_POLLING;
		}
	}
	else if( writeStatus.stage == WS_COMPLETE )
	{
		result = writeStatus.result;
		if( result == SD_OK )
		{
			/* ŏIĂ̂őSTCY */
			*size = blockSize;
			writeStatus.stage = WS_NONE;
		}
		else
		{
			/* sĂ̂ŃTCY = 0 */
			*size = 0;
			writeStatus.stage = WS_NONE;
		}
	}
	else if( writeStatus.stage == WS_NONE )
	{
		/* JnĂȂ */
		result = SD_ERR_POLLING;
	}
	else
	{
		/* WS_START				*/
		/* WS_WAIT_CMD_SEND		*/
		/* WS_WAIT_RESPONSE		*/
		
		/* ܂ĂȂ */
		*size = 0;
	}
	return result;
}

/****************************************************************************/
/* T  v																	*/
/*        read/write ̃\[X҂									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         unsigned short SD_OK:IA									*/
/*                        SD_ERR_RESOURCE_TIME_OUT ^CAEg				*/
/*   																	*/
/*         \[X̂҂B									*/
/****************************************************************************/
unsigned short waitResource( void )
{
	unsigned long i;
	unsigned short err = SD_ERR_RESOURCE_TIME_OUT;

	for(i = 0L; i < 100000UL; i++)
	{
		/* gp read/write I܂ő҂ */
		if( ((readStatus.stage == RS_NONE) || (readStatus.stage == RS_COMPLETE )) &&
			((writeStatus.stage == WS_NONE) || (writeStatus.stage == WS_COMPLETE )) )
		{
			err = SD_OK;
			break;
		}
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[hCSDWX^ǂݎ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK         												*/
/*         SD_ERR_CSD_...siڍׂ̓wb_t@CQƂ̂Ɓj				*/
/*   																	*/
/*        R1 X|X`œǂݎ										*/
/****************************************************************************/
unsigned short ReadAndCheckCsd( void )
{
	unsigned short retCode = SD_OK;

	retCode = GetR1ResponseData( CMD_SEND_CSD,			/* CMD GET CSD */
							 0UL,						/* 	*/
							 SD_CSD_LEN,				/* CSD length */
							 (char*)csd.byte,			/* CSD store Buffer. */
							 SD_WAIT_REGISTER_TOKEN );	/* CSD ͌Œ̑҂ԂƂ */

	if( retCode == SD_OK )	retCode = CheckCsd();		/* CSD ẽ`FbN */
	if( retCode != SD_OK)	retCode |= SD_ERR_CSD;		/* CSD G[R[hݒ	*/

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        ubNTCY 512 oCgɂ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK         												*/
/*         SD_ERR_...siڍׂ̓wb_t@CQƂ̂Ɓj					*/
/*   																	*/
/*         2G  SDJ[h̓ubNTCY 1024 oCgƂȂĂB	*/
/*        ABSR ̈ʒuȂǔzu̍l 512 oCg 1 ZN^Ƃč\	*/
/*        ĂB														*/
/*         ɃubNTCY 512 oCgɂB							*/
/****************************************************************************/
unsigned short changeBlockSize( void )
{
	unsigned short err = SD_ERR_CHENGE_BLOCK_SIZE;
	unsigned short response = SD_DRV_ERR_VAL;

	SetSdOnChipsel( TRUE );							/* CS ON */

	if( publishCmd( CMD_SET_BLOCKLEN, 512UL ) != FALSE )		/* ubNTCYύX		*/
	{
		response = waitForReply( RESPONSE_R1_MASK, 0x00, SD_WAIT_CMD_RESPONSE );	/* R}hX|X҂ */
	}

	SetSdOnChipsel( FALSE );						/* CS OFF */
	SendSdOne( '\xff' );

	blockSize = 512;								/* ubNTCYύX	*/
	if( response == SD_DRV_ERR_VAL )
	{
		err = SD_ERR_CHENGE_BLOCK_SIZE;
	}
	else if( response == 0x00 )
	{
		err = SD_OK;
	}
	else
	{
		err = BitToNum( response ) + 1;
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        CSD ̓emF												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/****************************************************************************/
unsigned short CheckCsd( void )
{

	unsigned short retCode = SD_OK;

	dataResponseTimeout = 0L;								/* f[^^CAEgvZ		*/

	/*`FbN				*/
	if( csd.field.always1 != 1 ) retCode = SD_ERR_CSD_CHECK_BIT; /* 1ȊOG[ */

	/* nj	*/
	else
	{
		/* ɒʐM[gvZ */
		syncRate = CalcRate( );						/* ʐM[ǧvZƍXV	*/
		dataResponseTimeout = CalcReadTimeout( );	/* ǂݍ݃^CAEgvZ				*/

		blockSize = (unsigned short)CalcBlockSize();	/* ubNTCYvZ */
		cardSize = CalcCardSize( );				/* J[hTCYvZ	*/

	}

	return  retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        ǂݍ݃^CAEgvZ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*         ʐM̃NbNŌvẐŐ CalcRate()ŒʐM[gvZ	*/
/*        ĂƁII													*/
/*                                                                          */
/*          TAAC+NSAC														*/
/*          TAAC exponent(TE)												*/
/*              0:1ns	4:10us												*/
/*              1:10ns	5:100us												*/
/*              2:100ns	6:1ms												*/
/*              3:1us	7:10ms												*/
/*          TAAC mantissa(TM)												*/
/*              0:~    4:1.5   8:3.5   c:5.5								*/
/*              1:1.0   5:2.0   9:4.0   d:6.0								*/
/*              2:1.2   6:2.5   a:4.5   e:7.0								*/
/*              3:1.3   7:3.0   b:5.0   f:8.0								*/
/*                                                                          */
/*          ҂ԂʐM̃oCgɒĎ							*/
/*             TE~TM(8/rate)												*/
/*             = TE~TM~rate/8												*/
/*              TE  t(TErec)ŎĂ̂ňȉ̂悤ɌvZ		*/
/*              TM~rate/(8~TErec)											*/
/*          NSAC															*/
/*              NSAC~100 NbN											*/
/*          Œl SD_WAIT_DATA_RESPONSE oCgƂB					*/
/*          ANZX^C̓f[^󂯎R}h𔭍sAf[^	*/
/*         󂯂͂߂܂ł̎ԁB											*/
/****************************************************************************/
unsigned long CalcReadTimeout( void )
{
	/* TAAC exponent Ήe[u			*/
	/* 1/(100x) ۂ̎			*/
	/* I[o[t[̂ 1/100 Ŏ	*/
	const static unsigned long TaacExpTable[] =
	{
		10000000UL,		/* 1ns     1GHz */
		 1000000UL,		/* 10ns  100MHz */
		  100000UL,		/* 100ns  10MHz */
		   10000UL,		/* 1us     1MHz */
		    1000UL,		/* 10us  100kHz */
		     100UL,		/* 100us  10kHz */
		      10UL,		/* 1ms     1kHz */
		       1UL		/* 10ms  100Hz */
	};

	/* TAAC mantissa Ήe[u	*/
	/* 10 {Ď				*/
	/* rbg[gȉׂ̂͂ĂPoCg̑҂ԂƂ	*/
	const static unsigned long TaacManTable[] =
	{
		80UL,		/* 0:i^CAEgőɂj */
		10UL,		/* 1:1.0 */
		12UL,		/* 2:1.2 */
		13UL,		/* 3:1.3 */
		15UL,		/* 4:1.5 */
		20UL,		/* 5:2.0 */
		25UL,		/* 6:2.5 */
		30UL,		/* 7:3.0 */
		35UL,		/* 8:3.5 */
		40UL,		/* 9:4.0 */
		45UL,		/* a:4.5 */
		50UL,		/* b:5.0 */
		55UL,		/* c:5.5 */
		60UL,		/* d:6.0 */
		70UL,		/* e:7.0 */
		80UL,		/* f:8.0 */
	};

	/* TAAC ő҂̒ʐMoCgvZ */
	unsigned long ratePer100;							/* [g1/100 */
	unsigned long TaacExp;								/* w */
	unsigned long TaacMan;								/*  */
	unsigned long TaacWaitByte = 1UL;

	/* TaacUnit  3 rbgȂ̂ŃG[ɂȂ悤ߔ͈̓`FbN͂ȂȂ */
	TaacExp = TaacExpTable[csd.field.taacUnit];			/* w */
	/* TaacValue  0 ͖ftHglĂ̂ł̂܂܎gp */
	/* l TaacValue 4 rbĝߔ͈̓`FbNsv */
	TaacMan = TaacManTable[csd.field.taacValue];		/*  */
	TaacWaitByte = 1;
	/*  PoCg̎Ԃ蒷ꍇvZB		*/
	/*  Zꍇ͏l̂PoCg̎ԂƂĂ		*/
	/* 													*/
	/* exp : Exponential ̋t(1/100)					*/
	/* rate: ʐM[gi8/rete = 1 oCg̒ʐM	*/
	/*    ƂTaacWaitBytevZꍇ́A		*/
	/* 1/(exp*100)  > 8/rate							*/
	/* rate         > 8*exp*100							*/
	/* rate/800     > exp								*/
	/* 													*/
	if( TaacExp < ( syncRate / 800UL  ) )
	{
		/* ʐM[g 1/100 ŌvZ */
		/* unsigned long ̍ől 4G Ȃ̂	*/
		/* [g 4G/80 𒴂ƃI[o[t[邽 */
		ratePer100 = 1;
		if( syncRate > 100UL )
		{
			ratePer100 = syncRate / 100UL;
		}
		/* TM~rate/(8~TErec) [͐؂グ		*/
		/* TM 10{ŕێĂ̂ŕ10{ */
		/* rate  1/100 Ȃ̂ŕq 1/100 Kv͂Ȃ */
		TaacWaitByte = ( TaacMan * ratePer100 + (80L * TaacExp-1))/(80L * TaacExp);
	}

	/* NSAC ő҂̒ʐMoCgvZ  */
	/* NSAC 100 NbNPʂ̃NbNȂ̂ 8 ŊĐ؂グ */
	if( csd.field.nsac != 0 )
	{
		TaacWaitByte += ((unsigned long)csd.field.nsac * 100L +7L)/8L;
	}

	/* Œlݒ肷 */
	if( TaacWaitByte < SD_WAIT_DATA_RESPONSE )
	{
		TaacWaitByte = SD_WAIT_DATA_RESPONSE;
	}

	return TaacWaitByte;
}

/****************************************************************************/
/* T  v																	*/
/*        ʐM[gvZő̃[gɕύX							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        ʐM[g														*/
/*         G[ 0														*/
/*   																	*/
/*        J[hΉłő̒ʐM[gvZhCoK肵ő	*/
/*       ̃[gxꍇ͉\ȍő̃[gɕύXBhCoK	*/
/*       [g̕xꍇ̓hCőK肵[gɕύXB		*/
/*        ʐM[g 20Mbps ƂƂɂȂĂ邪dlł800Mbps ܂	*/
/*       Kł邱ƂɂȂĂBɌĂ܂őΉł悤ɂ	*/
/*       ĂB															*/
/*         CSD WX^̓esȏꍇ͒x[gݒ肷B			*/
/****************************************************************************/
unsigned long CalcRate( void )
{
	unsigned long rate;
	unsigned long rateExp,rateMan;

	/* Rate exponent Ήe[u			*/
	/* 1/10 Ŏ						*/
	const static unsigned long rateExpTable[] =
	{
		  10000UL,		/* 100Kbps */
		 100000UL,		/* 1Mbps */
		1000000UL,		/* 10Mbps */
	   10000000UL		/* 100Mbps */
	};

	/* rate mantissa Ήe[u	*/
	/* 10 {Ď				*/
	const static unsigned long rateManTable[] =
	{
		10UL,		/* 0: */
		10UL,		/* 1:1.0 */
		12UL,		/* 2:1.2 */
		13UL,		/* 3:1.3 */
		15UL,		/* 4:1.5 */
		20UL,		/* 5:2.0 */
		25UL,		/* 6:2.5 */
		30UL,		/* 7:3.0 */
		35UL,		/* 8:3.5 */
		40UL,		/* 9:4.0 */
		45UL,		/* a:4.5 */
		50UL,		/* b:5.0 */
		55UL,		/* c:5.5 */
		60UL,		/* d:6.0 */
		70UL,		/* e:7.0 */
		80UL,		/* f:8.0 */
	};

	rateExp = rateExpTable[0];					/* ftHgŒɂĂ		*/
	if( csd.field.rateUnit <= 3 )				/* RATE ̎w 0`3 ͂nj	*/
	{
		rateExp = rateExpTable[csd.field.rateUnit];
	}

	/* rateValue 0 ͖ftHgl̂ł̂܂܎gp */
	rateMan = rateManTable[csd.field.rateValue];

	rate = rateExp * rateMan;					/* ő̒ʐM[g߂ */
	if( rate > SD_MAX_SYNC_RATE )
	{
		rate = SD_MAX_SYNC_RATE;				/* hCoK肵[g𒴂Ȃ悤ɂ */
	}

	if( ChangeSdRate( rate ) == FALSE )			/* ʐM[g̕ύX */
	{
		rate = SD_INITIAL_SYNC_RATE;			/* s͏[gɂĂ */
	}

	return rate;

}

/****************************************************************************/
/* T  v																	*/
/*        ubNTCYvZ											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*        ubNTCYvZ											*/
/*        ubNTCY 2  csd.field.blockLength B					*/
/****************************************************************************/
unsigned long CalcBlockSize( void )
{
	return Pow(2UL, (unsigned long)csd.field.blockLength);
}

/****************************************************************************/
/* T  v																	*/
/*        J[hTCYvZ											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*        J[hTCY͈ȉ̂悤ɌvZB								*/
/*																			*/
/*        [2  (cSizeMulti + 2) ] ~ [cSize + 1] ~ ubN			*/
/*																			*/
/*        ̂ߐɃubN cardInfo.blockSize Ɋi[Ă	*/
/*       ƁB																*/
/****************************************************************************/
unsigned long CalcCardSize( void )
{
	unsigned long cSize;
	unsigned long multi;

	cSize = (((unsigned long)csd.field.cSize0) << 10)|
			(((unsigned long)csd.field.cSize1) << 2) |
			( (unsigned long)csd.field.cSize2);
	cSize += 1UL;

	multi = (((unsigned long)csd.field.cSizeMult0) << 1) |
			( (unsigned long)csd.field.cSizeMult1);
	multi += 2UL;

	return Pow(2UL, multi) * cSize * (unsigned long)blockSize;	/* J[hTCYvZ */

}

/****************************************************************************/
/* T  v																	*/
/*        ZN^TCY擾											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        ubNTCY													*/
/*   																	*/
/*        ubNTCY擾BInitSdCard()sČʂ SD_OK	*/
/*       ƂȂĂ邱ƂmFB InitSdCard()sĂ鎞̌ʂ	*/
/*       ۏ؂ȂB														*/
/****************************************************************************/
unsigned short GetSdBlockSize( void )
{
	return blockSize;
}

/****************************************************************************/
/* T  v																	*/
/*        foCX̃TCY擾									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        J[hTCY														*/
/*   																	*/
/*        J[hTCY擾BInitSdCard()sČʂ SD_OK 	*/
/*       ƂȂĂ邱ƂmFB InitSdCard()sĂ鎞̌ʂ	*/
/*       ۏ؂ȂB														*/
/****************************************************************************/
unsigned long GetSdCardSize(  )
{
	return cardSize;
}

/****************************************************************************/
/* T  v																	*/
/*        R}hs														*/
/* p[^																*/
/*        cmdFR}hCfbNX											*/
/*        addrFR}hzւ̃|C^									*/
/* ߂l																	*/
/*        TRUE = 														*/
/*        FALSE = s														*/
/*   																	*/
/****************************************************************************/
unsigned short publishCmd( char cmd, unsigned long addr )
{
	unsigned short success = TRUE;

	transBuff[0] = (char)(0x40 + cmd);				/* "0x40" + (command index)" */
	transBuff[1] = (char)(addr >> 8L*3L);
	transBuff[2] = (char)(addr >> 8L*2L);
	transBuff[3] = (char)(addr >> 8L*1L);
	transBuff[4] = (char)(addr >> 8L*0L);
	transBuff[5] = 0x95;									/* Irbg SPI [hł͎gpȂ */
	

	if( SendSdBlock( transBuff, CMD_LEN ) != CMD_LEN )
	{
		success = FALSE;
	}

	return success;
}

/****************************************************************************/
/* T  v																	*/
/*        R}hs(񓯊)												*/
/* p[^																*/
/*        cmdFR}hCfbNX											*/
/*        addrFR}hzւ̃|C^									*/
/* ߂l																	*/
/*        TRUE = 														*/
/*        FALSE = s														*/
/*   																	*/
/****************************************************************************/
unsigned short kickCmd( char cmd, unsigned long addr )
{


	transBuff[0] = (char)(0x40 + cmd);				/* "0x40" + (command index)" */
	transBuff[1] = (char)(addr >> 8L*3L);
	transBuff[2] = (char)(addr >> 8L*2L);
	transBuff[3] = (char)(addr >> 8L*1L);
	transBuff[4] = (char)(addr >> 8L*0L);
	transBuff[5] = 0x95;									/* Irbg SPI [hł͎gpȂ */

	return SendSdKick( transBuff, CMD_LEN );
}

/****************************************************************************/
/* T  v																	*/
/*        ҂														*/
/* p[^																*/
/*        maskFX|X̂Ɏgprbg}XN邽߂̒l	*/
/*        compFmask Ń}XNʂƔrl							*/
/*        timeoutFMĔr										*/
/* ߂l																	*/
/*         0 ` 0x0ff : ASD_DRV_ERR_VAL Ȃ						*/
/*   																	*/
/*        ҂B														*/
/*        Mf[^ mask Ŏw肳ꂽʒũrbgocomp 	*/
/*        rB														*/
/*        timeout ͔r̉񐔁B											*/
/****************************************************************************/
unsigned short waitForReply( unsigned char mask, unsigned char comp, unsigned long timeout )
{

	unsigned long i = 0UL;
	unsigned short answer = SD_DRV_ERR_VAL;				/* PoCgM̖߂ */
	unsigned short tempRecv = SD_DRV_ERR_VAL;				/* PoCgM̖߂ */

	for( i = 0; i < timeout; ++i )
	{
		tempRecv = SendSdOne( '\xff' );
		if( tempRecv != SD_DRV_ERR_VAL )
		{
			if( ( (char)tempRecv & mask ) == comp )
			{
				answer = tempRecv;
				break;
			}
		}
	}

	return answer;

}

/****************************************************************************/
/* T  v																	*/
/*        WX^ǂݎėp֐										*/
/* p[^																*/
/*        cmd F R}h													*/
/*        parmF														*/
/*        len FWX^f[^											*/
/*        regBuffFWX^li[̈										*/
/*        timeOutFWX^ǂݎ̃^CAEgioCgj				*/
/* ߂l																	*/
/*        TRUE     														*/
/*        FALSE    s														*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short GetR1ResponseData(char cmd, unsigned long parm, unsigned short len, char * regBuff, unsigned long timeOut)
{
	unsigned short response = SD_DRV_ERR_VAL;
	unsigned short retCode = SD_OK;

	SetSdOnChipsel( TRUE );							/* CS ON */
	if( publishCmd( cmd, parm ) != FALSE )					/* transmit CMDn */
	{
		response = waitForReply( RESPONSE_R1_MASK, 0x00, SD_WAIT_CMD_RESPONSE );	/* ҂ */
	}
	if( response == 0x00 )
	{
		response = waitForReply( 0xff, DATA_TOKEN, timeOut );	/* g[N҂ */
		if( response == SD_DRV_ERR_VAL )
		{
			retCode = SD_ERR_TOKEN_RECEIVE_TIMEOUT;		/* g[N^CAEg */
		}
		else
		{
			if( RecvSdBlock( regBuff, '\xff', len ) != len )
			{
				retCode = SD_ERR_DATA_RECEIVE_TIMEOUT;	/* f[^M^CAEg */
			}
			else
			{
				SendSdRepeat( (char)0xff, 2 );		/* CRC  */
			}
		}
	}
	else if( response == SD_DRV_ERR_VAL )
	{
		retCode = SD_ERR_RESPONSE_TIMEOUT;				/* R}hAEg */
	}
	else
	{
		retCode = BitToNum((unsigned short)response)+1;		/* G[X|X */
	}

	SetSdOnChipsel( FALSE );					/* CS OFF */
	SendSdOne( '\xff' );

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        ON rbg̔ԍԂ												*/
/* p[^																*/
/*        bit rbgf[^													*/
/* ߂l																	*/
/*        bit E猩Ăŏ ON Bit ̈ʒuԍŕԂB			*/
/*        E[ 0BȂꍇ 16 ԂB							*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short BitToNum(unsigned short bit)
{
	unsigned short i = 0;
	unsigned short compareBit = 0x0001;
	for(i = 0; i < 16; ++i )
	{
		if( (bit & compareBit) != 0 )	break;
		compareBit <<= 1;
	}
	return i;
}

/****************************************************************************/
/* T  v																	*/
/*        ׂvZ														*/
/* p[^																*/
/*        baseF														*/
/*        n   Fw														*/
/* ߂l																	*/
/*        vZ															*/
/*   																	*/
/*        base  n vZB											*/
/****************************************************************************/
unsigned long Pow(unsigned long base, unsigned long n)
{
	unsigned long	i;
	unsigned long	answer;

	answer = 1;
	for( i = 0; i < n; i++ )
	{
		answer *= base;
	}
	return	answer;
}

/****************************************************************************/
/****************************************************************************/
/* 荞݂̓															*/
/****************************************************************************/
/****************************************************************************/
void InterruptDma0A( void )
{
	CompleteDma0A();
}
void InterruptDma0B( void )
{
	CompleteDma0B();
}
void InterruptTxi0( void )
{
	CompleteTxi0();				/* DMA ʐM̏I */
}

void InterruptTei0( void )
{
	CompleteTei0();				/* 荞ݗvNA */
	readSdControl( );			/* 񓯊 read */
	writeSdControl( );			/* 񓯊 write */
}

/****************************************************************************/
/****************************************************************************/
/* fobOp֐															*/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        CSD擾														*/
/* p[^																*/
/*        csdBuffFCSD i[̈												*/
/* ߂l																	*/
/*        TRUE     														*/
/*        FALSE    s														*/
/*   																	*/
/*        																	*/
/****************************************************************************/
int GetCsd( char * csdBuff )
{
	int i = 0;

	for( i = 0; i < SD_CSD_LEN; ++i )
	{
		*(csdBuff+i) = (char)csd.byte[i];
	}

	return TRUE;
}

/****************************************************************************/
/* T  v																	*/
/*        hCõo[W擾									*/
/* p[^																*/
/*        verFo[Wi[̈											*/
/* ߂l																	*/
/*        SD_OK o[W擾											*/
/*   																	*/
/*        o[W擾												*/
/****************************************************************************/
void GetSdDrvVer( T_RF_DRV_VER * ver )
{
	ver->ver = SD_DRV_VERSION;							/* hCoo[W */
	ver->type = SD_DRV_TYPE;							/* ^Cv */

}

