/****************************************************************************/
/* T  vF SD J[hgpn[hEFAɃANZXhCo			*/
/*   F SD J[h SPI [hB									*/
/*               gpĂfoCX										*/
/*               ITU0, SCI0, PB-5,6,7										*/
/*               															*/
/*               DrvSdDmaSciItu DMAgpăNbNʐM	*/
/*              BMׂ̊͂ă|[OŌĂĂ̊ CPU		*/
/*              LB												*/
/*               ԑ ITU0 gpĂB							*/
/*               H8/3048  SCI0  MSB t@[XgŒʐMłȂ̂ SD 	*/
/*               J[hhCoƂĂ SCI0 ƂĂB				*/
/* 쐬F 2004.09.11														*/
/* XVF 2014.02.23														*/
/* Copyright    resove														*/
/****************************************************************************/

#include	"3048F.H"
#include	"DrvSdDmaSciItu.h"
#include	"DrvCpuXtal.h"
#include	"TraceOut.h"

/* NbNŃ{[[gvZ}N					*/
/* ľܓ邽ߕ̔𕪎qɑĂB	*/
/* ..._PER4 ̓ӂ1/4BRRɐݒ肷邽߂̃}N	*/
/* l_PER8A_PER16 /8A/16 pB			*/
#define		SCI_SYNC_RATE_PHI( rate )		(unsigned short)((CPU_XTAL/4L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)
#define		SCI_SYNC_RATE_PHI_PER4( rate )	(unsigned short)((CPU_XTAL/16L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)
#define		SCI_SYNC_RATE_PHI_PER16( rate )	(unsigned short)((CPU_XTAL/64L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)
#define		SCI_SYNC_RATE_PHI_PER64( rate )	(unsigned short)((CPU_XTAL/256L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)

#define		A_BYTE_TRANS_TIME			( 1000 )		/* PoCg̑M҂[v */

/* SCMR ̒` 3048F.H ɖ̂Œ` */
union un_scmr {							/* SCMR          */
	unsigned char BYTE;					/*  Byte Access */
	struct {							/*  Bit  Access */
		unsigned char reserve  :4;
		unsigned char SDIR     :1;		/*    SDIR      */
		unsigned char SINV     :1;		/*    SINV      */
		unsigned char reserve2 :1;
		unsigned char SMIF     :1;		/*    SMIF      */
	}
	BIT;								/*              */
};

#define SCMR    (*(volatile union un_scmr  *)0xFFFFB6) /* SCMR  Address*/

/* SCIx.SCR rbgʒu */
#define SCI_SCR_TIE			( 0x80 )			/* gX~bgC^vgCl[u */
#define SCI_SCR_RIE			( 0x40 )			/* V[uC^vgCl[u */
#define SCI_SCR_TE			( 0x20 )			/* gX~bgCl[u */
#define SCI_SCR_RE			( 0x10 )			/* V[uCl[u */

/* DMA Nv */
#define DMA_FACT_ITU0		( 0 )				/* ITU0 ̃RyA}b`荞 */
#define DMA_FACT_ITU1		( 1 )				/* ITU1 ̃RyA}b`荞 */
#define DMA_FACT_ITU2		( 2 )				/* ITU2 ̃RyA}b`荞 */
#define DMA_FACT_ITU3		( 3 )				/* ITU3 ̃RyA}b`荞 */
#define DMA_FACT_SCI0_SND	( 4 )				/* SCI1 ̑Mobt@GveB荞 */
#define DMA_FACT_SCI0_RCV	( 5 )				/* SCI0 ̎Mobt@t荞 */
#define DMA_FACT_DREQ_DWN	( 6 )				/* DREQ ̗GbW */
#define DMA_FACT_DREQ_LOW	( 7 )				/* DREQ  low x*/

/* DMA  DTCR WX^rbgʒu */
#define DMA_DTCR_DTS0		( 0x01 )			/* f[^gXt@[ZNg */
#define DMA_DTCR_DTS1		( 0x02 )			/* f[^gXt@[ZNg */
#define DMA_DTCR_DTS2		( 0x04 )			/* f[^gXt@[ZNg */
#define DMA_DTCR_DTIE		( 0x08 )			/* 荞݋					*/
#define DMA_DTCR_RPE		( 0x10 )			/* s[g[h				*/
#define DMA_DTCR_DTID		( 0x20 )			/* MAR CNg^fNg*/
#define DMA_DTCR_DTSZ		( 0x40 )			/* f[^TCY					*/
#define DMA_DTCR_DTE		( 0x80 )			/* Cl[u					*/

/* DMA ̃[h */
#define DMA_MODE_IDLE		( DMA_DTCR_RPE|DMA_DTCR_DTIE )	/* ACh[h */
#define DMA_MODE_REPEAT		( DMA_DTCR_RPE )	/* s[g[h */
#define DMA_MODE_IO			( DMA_DTCR_DTIE )	/* I/O [h */

#define DMA_MODE_WORD		( DMA_DTCR_DTSZ )	/* f[^TCY = WORD	*/
#define DMA_MODE_INC		( 0 )				/* MAR CNg	*/
#define DMA_MODE_DEC		( DMA_DTCR_DTID )	/* MAR fNg		*/

typedef enum e_dma_status
{
	RESOURCE_STA_NO_USE = 0,			/* gp */
	RESOURCE_STA_READ,				/* READ  Ŏgp */
	RESOURCE_STA_FILL,				/* FILL  Ŏgp */
	RESOURCE_STA_WRITE				/* WRITE Ŏgp */
} T_DMA_STATUS;

static T_DMA_STATUS resourceStatus = RESOURCE_STA_NO_USE;		/* DMA gp */
static unsigned short lastDmaLen = 0;
static char sendWk;						/* 1oCgMŎgp */
static char receiveWk;						/* 1oCgMŎgp */


/****************************************************************************/
/* ֐																	*/
/****************************************************************************/

static unsigned short RateToBrr( unsigned long rate );			/* ʐM[g CSK, BRR ɐݒ肷lvZ */
static void initDmaShort( struct st_sam * dmaAddr,
									void * ioAddr );			/* DMA V[gAhX[h̏ */
static void startDmaShort( struct st_sam * dmaAddr,
							unsigned char mode,
							char * pMem,
							unsigned short len );				/* DMA V[gAhX[hŋN */

/****************************************************************************/
/* T  v																	*/
/*        SCI													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        VA|[g̏ȂBpower ON Ɉ񂾂ȂB	*/
/*         SD J[hƂ̒ʐMe										*/
/*          E݋֎~													*/
/*          ENbN												*/
/*          EMSB t@[Xg												*/
/*         SCI łPoCg̑M͊荞݂gpȂ̂ŁAł	*/
/*         荞݋͂ȂBDMA N鎞Ɋ荞݋ƂB		*/
/****************************************************************************/
void InitSdTrans( void )
{
	unsigned short i;
	unsigned short cksBrr;

	cksBrr = RateToBrr( SD_INITIAL_SYNC_RATE );		/* [gݒ߂	*/

	SCI0.SCR.BIT.TE = 0;							/* M֎~ */
	SCI0.SCR.BIT.RE = 0;							/* M֎~ */
	SCMR.BIT.SDIR = 1;								/* MSB first */
	SCI0.SMR.BIT.CA		= 1; 						/* NbN */
	SCI0.SMR.BIT.CKS = (unsigned char)(cksBrr >> 8);/* clock = ӁA/4A/16A/64 */
	SCI0.BRR = (unsigned char)cksBrr;				/* bit rate */
	for( i = 0; i < A_BYTE_TRANS_TIME; ++i);		/* wait 1bit priod */
	SCI0.SCR.BYTE = SCI_SCR_TE|SCI_SCR_RE;			/* M */

	initDmaShort( &DMAC0A, &SCI0.RDR );				/* DMAC0A  SCI0 ̎MŎgƂ */
	initDmaShort( &DMAC0B, &SCI0.TDR );				/* DMAC0B  SCI0 ̑MŎgƂ */

	resourceStatus = RESOURCE_STA_NO_USE;

}

/****************************************************************************/
/* T  v																	*/
/*        PoCgM												*/
/* p[^																*/
/*        transmitData														*/
/*          Mf[^														*/
/* ߂l																	*/
/*        Mf[^													*/
/*        SD_DRV_ERR_VAL = MG[										*/
/*   																	*/
/*       MG[ SD_DRV_ERR_VAL Ԃ								*/
/*       M̓|[OłȂ̂Ŋ荞݋֎~ɂB				*/
/****************************************************************************/
unsigned short SendSdOne( char transmitData )
{
	unsigned short receiveData = SD_DRV_ERR_VAL;	/* Mf[^ */
	unsigned short i = 0;							/* [ṽCfbNX */
	unsigned short j = 0;							/* [ṽCfbNX */

	SCI0.SCR.BIT.RIE  = 0;							/* M荞݋֎~ɖ߂ */
	for( i = 0; i < A_BYTE_TRANS_TIME; ++i )		/* ȎM҂ */
	{
		if( SCI0.SSR.BIT.TDRE == 1 )
		{
			/* 1oCgM */
			SCI0.TDR = (unsigned char)transmitData;	/* write transmit data */
			SCI0.SSR.BIT.TDRE = 0;					/* transmit start */
			break;
		}
	}
	if( i < A_BYTE_TRANS_TIME )
	{
		for( j = 0; j < A_BYTE_TRANS_TIME; ++j )	/* M҂	*/
		{
			if( SCI0.SSR.BIT.RDRF == 1 )
			{
				/* 1oCgM */
				receiveData = (unsigned short)(SCI0.RDR & 0x00ff);	/* read RDR */
				SCI0.SSR.BIT.RDRF = 0;				/* clear RDR full flag */
				break;
			}
		}
	}

	return( receiveData );
}

/****************************************************************************/
/* T  v																	*/
/*        z̎MƌŒf[^̑MȂ							*/
/* p[^																*/
/*        receiveBuffFMobt@											*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        MoCg													*/
/*   																	*/
/*        M͂PoCg̃f[^JԂȂBMf[^ 		*/
/*       receiveBuff ɂȂׂĊi[B									*/
/*        ĂяoőMƎMrāAf	*/
/*       邱ƁB															*/
/****************************************************************************/
unsigned short RecvSdBlock( char * receiveBuff, char transData, unsigned short len )
{
	unsigned short receiveLen = 0;
	T_SD_POLL pollStatus = SD_POLL_CONTINUE;

	if( RecvSdKick( receiveBuff, transData, len ) != FALSE )		/* MJn				*/
	{

		while( pollStatus == SD_POLL_CONTINUE )
		{
			pollStatus = SdDmaPoll( &receiveLen );		/* MoߊmF			*/
		}

		if( pollStatus != SD_POLL_COMPLETE )
		{
			receiveLen = 0;
		}
	}

	return receiveLen;								/* MԂ	*/
}

/****************************************************************************/
/* T  v																	*/
/*        z̑MȂ												*/
/* p[^																*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        M														*/
/*   																	*/
/*        w肵̃f[^AđMBMf[^͔jB*/
/*       AM񐔂͐ĂĖ߂lƂĕԂB						*/
/*        M^CAEgȂǂɂ莸sꍇ͒fB			*/
/****************************************************************************/
unsigned short SendSdBlock( char * transBuff, unsigned short len )
{
	unsigned short receiveLen = 0;
	T_SD_POLL pollStatus = SD_POLL_CONTINUE;

	if( SendSdKick( transBuff, len ) != FALSE )
	{
		/* I܂ő҂ */
		while( pollStatus == SD_POLL_CONTINUE )
		{
			pollStatus = SdDmaPoll( &receiveLen );		/* MoߊmF			*/
		}

		if( pollStatus != SD_POLL_COMPLETE )
		{
			receiveLen = 0;
		}
	}

	return receiveLen;									/* MԂ */

}

/****************************************************************************/
/* T  v																	*/
/*        Œf[^̘AMȂ									*/
/* p[^																*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        M														*/
/*   																	*/
/*        f[^w肵񐔘AđMBMf[^͔j	*/
/*       BAM񐔂͐ĂĖ߂lƂĕԂB					*/
/*        M^CAEgȂǂɂ莸sꍇ͒fB			*/
/****************************************************************************/
unsigned short SendSdRepeat( char transData, unsigned short len )
{
	unsigned short receiveLen = 0;
	T_SD_POLL pollStatus = SD_POLL_CONTINUE;

	if( RepeatSdKick( transData, len ) != FALSE )		/* MJn				*/
	{

		while( pollStatus == SD_POLL_CONTINUE )
		{
			pollStatus = SdDmaPoll( &receiveLen );		/* MoߊmF			*/
		}

		if( pollStatus != SD_POLL_COMPLETE )
		{
			receiveLen = 0;
		}
	}

	return receiveLen;								/* MԂ	*/
}


/****************************************************************************/
/* T  v																	*/
/*        z̎MƌŒf[^̑MJn							*/
/* p[^																*/
/*        receiveBuffFMobt@											*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        TRUEFAFALSEFs											*/
/*   																	*/
/*        I̊mF SdDmaPoll()łȂB								*/
/****************************************************************************/
unsigned short RecvSdKick( char * receiveBuff, char transData, unsigned short len )
{
	unsigned short success = FALSE;

	if( resourceStatus == RESOURCE_STA_NO_USE )
	{
		/* gpȂsł */
		resourceStatus = RESOURCE_STA_READ;				/* READ Ŏgp̃Xe[^X */
		lastDmaLen = len;
		sendWk = transData;

		SCI0.SCR.BIT.RIE  = 0;						/* M荞݋֎~ɂ */
/*		SCI0.SCR.BIT.TIE  = 0;						/* M荞݋֎~ɂ */
		/* MJn */
		startDmaShort( &DMAC0A,						/* DMA WX^ */
					DMA_MODE_IO |					/* I/O [h	*/
					DMA_MODE_INC |					/* AhXCNg */
					DMA_FACT_SCI0_RCV,				/* SCI0 MŋN	*/
					receiveBuff,					/* Mobt@AhX */
					len );
		SCI0.SCR.BIT.RIE  = 1;						/* M荞݋ɂ */

		/* Mݒ */
		startDmaShort( &DMAC0B,						/* DMA WX^ */
					DMA_MODE_IDLE |					/* ACh[h	*/
					DMA_FACT_SCI0_SND,				/* SCI0 MŋN	*/
					&sendWk,						/* Mf[^AhX */
					len );
		SCI0.SCR.BIT.TIE  = 1;						/* M荞݋ɂ */
		SCI0.SCR.BIT.TEIE  = 1;						/* M荞݋ɂ */
		success = TRUE;
	}

	return success;									/* MԂ */

}

/****************************************************************************/
/* T  v																	*/
/*        z̑MJn												*/
/* p[^																*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        TRUEFAFALSEFs											*/
/*   																	*/
/*        I̊mF SdDmaPoll()łȂB								*/
/****************************************************************************/
unsigned short SendSdKick( char * transBuff, unsigned short len )
{
	unsigned short success = FALSE;

	if( resourceStatus == RESOURCE_STA_NO_USE )
	{
		/* gpȂsł */
		resourceStatus = RESOURCE_STA_WRITE;		/* WRITE Ŏgp̃Xe[^X */
		lastDmaLen = len;

		SCI0.SCR.BIT.RIE  = 0;						/* M荞݋֎~ɖ߂ */

		/* MJn */
		startDmaShort( &DMAC0A,						/* DMA WX^ */
					DMA_MODE_IDLE |					/* ACh[h	*/
					DMA_FACT_SCI0_RCV,				/* SCI0 MŋN	*/
					&receiveWk,						/* M̈PoCg͕Kv */
					len );
		SCI0.SCR.BIT.RIE  = 1;						/* M荞݋ɂ */

		/* Mݒ */
		startDmaShort( &DMAC0B,						/* DMA WX^ */
					DMA_MODE_IO |					/* I/O[h	*/
					DMA_MODE_INC |					/* MAhXCNg */
					DMA_FACT_SCI0_SND,				/* SCI0 MŋN	*/
					transBuff,						/* Mf[^AhX */
					len );
		SCI0.SCR.BIT.TIE  = 1;						/* M荞݋ɂ */
		SCI0.SCR.BIT.TEIE  = 1;						/* M荞݋ɂ */
		success = TRUE;
	}

	return success;									/* MԂ */

}

/****************************************************************************/
/* T  v																	*/
/*        Œf[^̘AMȂ									*/
/* p[^																*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        TRUEFAFALSEFs											*/
/*   																	*/
/*        f[^̌JԂMNB								*/
/*        I̊mF SdDmaPoll()łȂB								*/
/****************************************************************************/
unsigned short RepeatSdKick( char transData, unsigned short len )
{
	unsigned short success = FALSE;
	sendWk = transData;

	if( resourceStatus == RESOURCE_STA_NO_USE )
	{
		/* gpȂsł */
		resourceStatus = RESOURCE_STA_WRITE;		/* WRITE Ŏgp̃Xe[^X */
		lastDmaLen = len;

		/* MJn */
		SCI0.SCR.BIT.RIE  = 0;						/* M荞݋֎~ɂĂ */
		startDmaShort( &DMAC0A,						/* DMA WX^ */
					DMA_MODE_IDLE |					/* ACh[h	*/
					DMA_FACT_SCI0_RCV,				/* SCI0 MŋN	*/
					&receiveWk,						/* M̈PoCg͕Kv */
					len );
		SCI0.SCR.BIT.RIE  = 1;						/* M荞݋ɂ */

		/* Mݒ */
		startDmaShort( &DMAC0B,						/* DMA WX^ */
					DMA_MODE_IDLE |					/* ACh[h	*/
					DMA_FACT_SCI0_SND,				/* SCI0 MŋN	*/
					&sendWk,						/* Mf[^AhX */
					len );
		SCI0.SCR.BIT.TIE  = 1;						/* M荞݋ɂ */
		SCI0.SCR.BIT.TEIE  = 1;						/* M荞݋ɂ */
		success = TRUE;
	}

	return success;									/* MԂ */

}

/****************************************************************************/
/* T  v																	*/
/*        DMA M̐imF										*/
/* p[^																*/
/*        lenFMς݂̃oCgi[								*/
/* ߂l																	*/
/*        TURE:AFALSEFs											*/
/*   																	*/
/*        RecvSdKick(),SendSdKick(),FillSdKick() s̐i󋵂𒲂ׂB	*/
/****************************************************************************/
T_SD_POLL SdDmaPoll( unsigned short * len )
{
	T_SD_POLL status = SD_POLL_CONTINUE;

	if( ( resourceStatus != RESOURCE_STA_NO_USE ) )
	{
		if( lastDmaLen != 0 )
		{
			*len = lastDmaLen - DMAC0A.ETCR;		/* łɓǂݎf[^ */
			status = SD_POLL_CONTINUE;
		}
		else
		{
			status = SD_POLL_ERROR;
		}
	}
	else
	{
		/* DMA gpI */
		*len = lastDmaLen;
		status = SD_POLL_COMPLETE;
	}

	return status;
}

/****************************************************************************/
/* T  v																	*/
/*        ʐM[gύX												*/
/* p[^																*/
/*        rate FʐM[g													*/
/* ߂l																	*/
/*        TRUE  FύX													*/
/*        FALSE FύXłȂ												*/
/*   																	*/
/*       w肵ʐM[gɕύX										*/
/*       M֎~ɂĂύX̌㌳ɖ߂							*/
/*       ʐMȂĂȂɎs邱ƁB							*/
/****************************************************************************/
unsigned short ChangeSdRate( unsigned long rate )
{
	unsigned short i = 0;
	unsigned short retCode = FALSE;
	unsigned short cksBrr = RateToBrr( rate );

	if( cksBrr != 0xffff )
	{
		SCI0.SMR.BIT.CKS = (unsigned char)(cksBrr >> 8);	/* clock =  */
		SCI0.BRR = (unsigned char )cksBrr;			/* bit rate */
		for( i = 0; i < A_BYTE_TRANS_TIME; ++i);	/* wait 1bit period */
		retCode = TRUE;
	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        ʐM[g BRR ɐݒ肷lvZ							*/
/* p[^																*/
/*        rate FʐM[g													*/
/* ߂l																	*/
/*        ʁFCKS ɐݒ肷l											*/
/*        ʁFBRR ɐݒ肷l											*/
/*        ݒłȂʐM[g̎ 0xffff ݒ肳B				*/
/*   																	*/
/*       ʐM[g CKS,BRR WX^ɐݒ肷lvZB			*/
/*       BRR  0 ͐ݒłȂƂƂĂB							*/
/****************************************************************************/
unsigned short RateToBrr( unsigned long rate )
{
	unsigned short retCode;
	if( ((CPU_XTAL/4UL)/2UL >= rate ) &&  ((CPU_XTAL/4UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI( rate );
	}
	else if(((CPU_XTAL/16UL)/2UL >= rate ) &&  ((CPU_XTAL/16UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI_PER4( rate ) | (unsigned short)(0x01 << 8);
	}
	else if(((CPU_XTAL/64UL)/2UL >= rate ) &&  ((CPU_XTAL/64UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI_PER16( rate ) | (unsigned short)(0x02 << 8);
	}
	else if(((CPU_XTAL/256UL)/2UL >= rate ) &&  ((CPU_XTAL/256UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI_PER64( rate ) | (unsigned short)(0x03 << 8);
	}
	else
	{
		retCode = 0xffff;
	}

	return retCode;
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/*	DMA ֘A																*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* T  v																	*/
/*        DMAV[gAhX[hŎgp邽߂̏Ȃ		*/
/* p[^																*/
/*        ioAddr FI/O ̃AhX											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        V[gAhX[hp̏֐BI/O AhXݒ肷B	*/
/*        IO AhX͖ݒ肷Kv̂ŏŃZbgĂB	*/
/****************************************************************************/
void initDmaShort( struct st_sam * dmaAddr,void * ioAddr )
{
	dmaAddr->IOAR = (unsigned char)((unsigned long)(ioAddr) & 0x00ffUL);	/* I/OWX^ */
}

/****************************************************************************/
/* T  v																	*/
/*        DMA̐ݒANȂ											*/
/* p[^																*/
/*        mode   F][h												*/
/*                 DMA_MODE_...  DMA_FACT_...  OR Őݒ肷B			*/
/*        dmaAddrFDMA WX^̃AhX									*/
/*        pMem   FAhX											*/
/*        len    F]TCY												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        V[gAhX[hp̐ݒ֐BݒȂƂ	*/
/*        DMA NB													*/
/*         DTE = 0 ̏Ԃ DTIE = 1 ƂƑ荞݂Ă܂̂	*/
/*        n߂ DTE  DTIE ȊÕrbgZbgĂ DTE Zbg	*/
/*        DTC 𓮍삳B̌ADTIE = 1 ƂĊ荞݋ƂB		*/
/*         As[g[hł DTIE = 1 ƂȂB					*/
/****************************************************************************/
void startDmaShort( struct st_sam * dmaAddr, unsigned char mode, char * pMem, unsigned short len )
{
	dmaAddr->MAR = pMem;								/* Mobt@AhX */
	dmaAddr->ETCR = len;								/* Mf[^ */
	dmaAddr->DTCR.BYTE = (unsigned char)(mode &
				 		(~(DMA_DTCR_DTIE|DMA_DTCR_DTE)));/* DTE,DTIE ͍Ōɐݒ肷 */
	dmaAddr->DTCR.BIT.DTE = 1;							/* Cl[u	*/
	dmaAddr->DTCR.BYTE |= (unsigned char)(mode & DMA_DTCR_DTIE);	/* 荞݋	*/

}

/****************************************************************************/
/* T  v																	*/
/*        DMA0A荞													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         DMA ̊荞݂ł͊荞݋֎~ƂB							*/
/****************************************************************************/
void CompleteDma0A( void )
{
	DMAC0A.DTCR.BIT.DTIE = 0;
}

/****************************************************************************/
/* T  v																	*/
/*        DMA0B荞													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         DMA ̊荞݂ł͊荞݋֎~ƂB							*/
/****************************************************************************/
void CompleteDma0B( void )
{
	DMAC0B.DTCR.BIT.DTIE = 0;
}

/****************************************************************************/
/* T  v																	*/
/*        TXI0(SCI0M)荞											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        obt@GveB荞										*/
/****************************************************************************/
void CompleteTxi0( void )
{
	SCI0.SCR.BIT.TIE  = 0;						/* M荞݋֎~ɖ߂	*/
}
/****************************************************************************/
/* T  v																	*/
/*        TEI0(SCI0MI)荞										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        MI荞													*/
/****************************************************************************/
void CompleteTei0( void )
{
	SCI0.SCR.BIT.TEIE  = 0;						/* M荞݋֎~ɖ߂	*/
	resourceStatus = RESOURCE_STA_NO_USE;		/* DMA 󋵂𖢎gp			*/

}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* ȉԊǗ																*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/* Ԃ ITU ̃JE^ɕϊ}N */
/* ̓O('L'tjƂ鎖II */
/* RgɏĂ鐔̓^C}JEgƂĐݒłC^[o}NƂĐݒł̂͐̂ */
#define ITU_COUNT_1_NS(n)	(unsigned short)((n)*( CPU_XTAL    /1000000L)/1000L-1L)	/* ns P   62.5ns<= n <  4,096S */
#define ITU_COUNT_2_NS(n)	(unsigned short)((n)*((CPU_XTAL/2L)/1000000L)/1000L-1L)	/* ns P    125ns<= n <  8,192S /2*/
#define ITU_COUNT_4_US(n)	(unsigned short)((n)*((CPU_XTAL/4L)/1000000L)-1L)		/* us P  0.25s<= n < 16,384S /4*/
#define ITU_COUNT_8_US(n)	(unsigned short)((n)*((CPU_XTAL/8L)/1000000L)-1L)		/* us P  0.5 s<= n < 32,768S /8*/

/****************************************************************************/
/* T  v																	*/
/*        ^C}̏Ȃ											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ITU0 1ms  RyA}b`悤ɐݒ肷				*/
/****************************************************************************/
void InitSdWait( void )
{
	ITU0.TCR.BIT.CCLR = 1;							/* counte clear at GRA compare match */
	ITU0.TCR.BIT.CKEG = 0; 							/* count at upper edge */
	ITU0.TCR.BIT.TPSC = 3; 							/* internal clock / 8 */
	ITU0.GRA = ITU_COUNT_8_US(1000L);				/* 1 msec */

}

/****************************************************************************/
/* T  v																	*/
/*        w莞Ԃ̑҂Ȃ											*/
/* p[^																*/
/*        timeFms Pʂ̑҂											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        GRA ̃RyA}b`̉񐔂𐔂B								*/
/*        RyA}b` 1ms Ŕ悤ɂȂĂ̂ł̉񐔂	*/
/*       ܂܎w莞ԂƂȂB												*/
/****************************************************************************/
void SdWaitTimer( short time)
{
	short i = 0;

	ITU0.TCNT = 0;								/* timer counter reset */
	ITU.TSTR.BIT.STR0 = 1; 						/* timer start */
	for( i = 0; i < time; ++i )
	{
	 	while( ITU0.TSR.BIT.IMFA == 0 );		/* wait compare match	 */
	 	ITU0.TSR.BIT.IMFA = 0;					/* clear compare match flag */
	}

 	ITU.TSTR.BIT.STR0 = 0; 						/* timer stop */
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* ȉ|[gANZX														*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        |[g̓o͂ݒ肷											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        XINSERT,XPROTECT,XCS|[g̏							*/
/****************************************************************************/
void InitSdPort( void )
{
	/* |[g */
	/* PB-5FXPROTECT	*/
	/* PB-6FXINSERT	*/
	/* PB-7FXCS		*/
	PB.DDR = 0x9f;		/* PB-7 o͂ɂ */
	PB.DR.BYTE = 0xff;		/* ALL ON */
	PB.DR.BIT.B7 = 0;		/* CS = 0		*/

}

/****************************************************************************/
/* T  v																	*/
/*        SD J[h̑}Ԃ擾										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        TRUE FJ[h}Ă										*/
/*        FALSEFJ[h}ĂȂ									*/
/*   																	*/
/*        XINSERT [q͔]Ă̂ŃJ[h̑}Ԃ𔽓]ĕԂ		*/
/****************************************************************************/
short GetSdInsert( void )
{
	short ret = TRUE;

	if( PB.DR.BIT.B6 != 0 )
	{
		ret = FALSE;
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        SD J[h݋֎~Ԃ擾								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        TRUE F݋֎~													*/
/*        FALSEF݋֎~ł͂Ȃ											*/
/*   																	*/
/*         XPROTECT [q͔]Ă̂ŃveNgԂ𔽓]ĕԂB	*/
/*         ɃJ[h̑}󋵂ăJ[h}ĂȂ͏݋֎~	*/
/*        ƂĂB														*/
/****************************************************************************/
short GetSdProtect()
{
	short ret = TRUE;
	if( GetSdInsert() != 0 )
	{
		if( PB.DR.BIT.B5 == 0)
		{
			ret = FALSE;
		}
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        SD J[h̃`bvZNg ON ɂ								*/
/* p[^																*/
/*        OnOff	TRUE F`bvZNg ON ɂ								*/
/*              FALSEF`bvZNg OFF ɂ							*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        XCS ͔]Ȃ̂ OnOff  TRUE ̎ 0 óAFALSE 1 o͂	*/
/*       B																*/
/****************************************************************************/
void SetSdOnChipsel( short OnOff )
{
	if( OnOff != 0 )
	{
		PB.DR.BIT.B7 = 0;
	}
	else
	{
		PB.DR.BIT.B7 = 1;
	}
}

