/****************************************************************************/
/* T  vF hCõG[R[h`							*/
/*   F 																*/
/* 쐬F 2011.09.25														*/
/* XVF 2013.09.30														*/
/* Copyright    resove														*/
/****************************************************************************/
#include "RfInterface.h"
#include "TstGeneral.h"
#include "TstOrgErrCode.h"
#include "DrvErrCode.h"

static const T_ERR_CODE_STR errCodeStr[] = {
	ERR_CODE_STR(SD_ERR_CMD_TIMEOUT),			/* R}h^CAEg			*/	
																	
	/* ֘A */												
	ERR_CODE_STR(SD_ERR_INIT_RESET_TIMEOUT),	/* Zbg^CAEg			*/	
	ERR_CODE_STR(SD_ERR_INIT_INIT_TIMEOUT),		/* CjVCY^CAEg	*/	
																	
	/* ݊֘A */												
	ERR_CODE_STR(SD_ERR_WRITE),					/* ݃G[				*/	
	ERR_CODE_STR(SD_ERR_WRITE_IN_IDLE_STATE),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_WRITE_ERASE_RESET),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_WRITE_ILLEGAL_COMMAND),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_WRITE_COM_CRC_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_WRITE_ERASE_SEQ_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_WRITE_ADDRESS_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_WRITE_PARAMETER_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_WRITE_TIMEOUT),			/* ݃^CAEg			*/	
	ERR_CODE_STR(SD_ERR_WRITE_RESPONSE_TIMEOUT),/* X|XM^CAEg	*/	
	ERR_CODE_STR(SD_ERR_WRITE_CRC_ERR),			/* ݎ CRC G[		*/	
	ERR_CODE_STR(SD_ERR_WRITE_PHYSICAL),		/* ݕIȃG[		*/	
	ERR_CODE_STR(SD_ERR_WRITE_OTHER),			/* ݗRsȃG[		*/	
																				
	/* ǂݍ݊֘A */															
	ERR_CODE_STR(SD_ERR_READ),					/* BLOCK READ G[			*/	
	ERR_CODE_STR(SD_ERR_READ_IN_IDLE_STATE),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_READ_ERASE_RESET),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_READ_ILLEGAL_COMMAND),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_READ_COM_CRC_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_READ_ERASE_SEQ_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_READ_ADDRESS_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_READ_PARAMETER_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_READ_DATA_RCV_TIMEOUT),	/* f[^M^CAEg		*/	
	ERR_CODE_STR(SD_ERR_READ_RESPONSE_TIMEOUT),	/* X|XM^CAEg	*/	
	ERR_CODE_STR(SD_ERR_READ_TOKEN_RCV_TIMEOUT),/* g[NM^CAEg		*/	
																		
	/* CSD ANZX֘A */													
	ERR_CODE_STR(SD_ERR_CSD),					/* CSD 擾G[				*/	
	ERR_CODE_STR(SD_ERR_CSD_IN_IDLE_STATE),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CSD_ERASE_RESET),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CSD_ILLEGAL_COMMAND),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CSD_COM_CRC_ERROR),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CSD_ERASE_SEQ_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CSD_ADDRESS_ERROR),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CSD_PARAMETER_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CSD_DATA_RCV_TIMEOUT),	/* f[^M^CAEg		*/	
	ERR_CODE_STR(SD_ERR_CSD_RESPONSE_TIMEOUT),	/* X|XM^CAEg	*/	
	ERR_CODE_STR(SD_ERR_CSD_TOKEN_RCV_TIMEOUT),	/* g[NM^CAEg		*/	
	ERR_CODE_STR(SD_ERR_CSD_CHECK_BIT),			/* CSD eG[				*/	
																		
	/* CID ANZX֘A */													
	ERR_CODE_STR(SD_ERR_CID),					/* CID 擾G[				*/	
	ERR_CODE_STR(SD_ERR_CID_IN_IDLE_STATE),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CID_ERASE_RESET),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CID_ILLEGAL_COMMAND),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CID_COM_CRC_ERROR),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CID_ERASE_SEQ_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CID_ADDRESS_ERROR),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CID_PARAMETER_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_CID_DATA_RCV_TIMEOUT),	/* f[^M^CAEg		*/	
	ERR_CODE_STR(SD_ERR_CID_RESPONSE_TIMEOUT),	/* X|XM^CAEg	*/	
	ERR_CODE_STR(SD_ERR_CID_TOKEN_RCV_TIMEOUT),	/* g[NM^CAEg		*/	
	ERR_CODE_STR(SD_ERR_CID_CHECK_BIT),			/* CID eG[				*/	
																		
	/* OCR ANZX֘A */													
	ERR_CODE_STR(SD_ERR_OCR),					/* OCR 擾G[				*/	
	ERR_CODE_STR(SD_ERR_OCR_IN_IDLE_STATE),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_OCR_ERASE_RESET),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_OCR_ILLEGAL_COMMAND),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_OCR_COM_CRC_ERROR),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_OCR_ERASE_SEQ_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_OCR_ADDRESS_ERROR),		/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_OCR_PARAMETER_ERROR),	/* R1 X|X				*/	
	ERR_CODE_STR(SD_ERR_OCR_DATA_RCV_TIMEOUT),	/* f[^M^CAEg		*/	
	ERR_CODE_STR(SD_ERR_OCR_RESPONSE_TIMEOUT),	/* X|XM^CAEg	*/	
	ERR_CODE_STR(SD_ERR_OCR_TOKEN_RCV_TIMEOUT),	/* g[NM^CAEg		*/	
																		
	/* v֘A */														
	ERR_CODE_STR(SD_ERR_REQ_ADDRESS),			/* AhXvG[			*/	
	ERR_CODE_STR(SD_ERR_REQ_LEN),				/* w̌				*/	
	ERR_CODE_STR(SD_ERR_DRV_INITIAL),			/* ĂȂ		*/	
	ERR_CODE_STR(SD_ERR_OVER_BOARDER),			/* E܂v				*/
	ERR_CODE_STR(SD_ERR_RESOURCE_TIME_OUT),		/* \[XL^CAEg		*/
	

	/* SD hCo */
	ERR_CODE_STR(SD_ERR_POLLING),				/* kick ĂȂ̂ poll */
	ERR_CODE_STR(SD_ERR_CHENGE_BLOCK_SIZE),		/* ubNTCYύXs		*/
};

/****************************************************************************/
/* T  v																	*/
/*        G[R[h當T										*/
/* p[^																*/
/*        errCodeFG[R[h												*/
/* ߂l																	*/
/*        Ή镶ւ̃|C^										*/
/*   																	*/
/*         																	*/
/****************************************************************************/
char * GetOrgErrCodeChar( unsigned short errCode )
{
	static const unsigned short recNum = sizeof(errCodeStr)/sizeof(T_ERR_CODE_STR);
	char * errStr = NULL;
	unsigned short i;

	for( i = 0; i < recNum; i++ )
	{
		if( errCodeStr[i].code == errCode )
		{
			errStr = errCodeStr[i].str;
			break;
		}
	}

	return errStr;
}

