/****************************************************************************/
/* T  vF t@CVXe move eXgpt@C							*/
/*   F 																*/
/* 쐬F 2005.06.19														*/
/* XVF 2014.02.15														*/
/* Copyright    resove														*/
/****************************************************************************/

/* #include <stdio.h>*/
#include <stdlib.h>
#include "RfInterface.h"
#include "TraceOut.h"
#include "TstWriteVal.h"
#include "TstDefine.h"
#include "RfGeneral.h"
#include "TstWriteFunc.h"

#define MANY_NUM				( 5 )

/****************************************************************************/
/* T  v																	*/
/*        t@Cړ̃eXg												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TestMove( void )
{
	unsigned short err;
	T_RF_FCB * pFcb;

	TEST_TITLE(("Test file move."));
	TestReady();

	/* make Test Environment. */
	err = RfMkDir( "\\sub1" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(sub1)");
	err = RfMkDir( "\\sub1\\sub2" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(sub2)");
	err = RfMkDir( "\\sub1\\sub2\\sub3" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(sub3)");
	err = RfMkDir( "\\sub1\\sub2\\sub3\\sub4" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(sub4)");
	err = RfMkDir( "\\sub1\\sub2\\sub3\\sub4\\sub5" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(sub5)");


	TestWriteSmallFile("\\sub1\\aaa11.txt" );			/* write(sub1\aaa11.txt) */
	TestWriteSmallFile("\\sub1\\aaa12.txt" );			/* write(sub1\aaa12.txt) */

	TestWriteSmallFile("\\sub1\\sub2\\aaa21.txt" );		/* write(sub1\sub2\aaa21.txt) */
	TestWriteSmallFile("\\sub1\\sub2\\aaa22.txt" );		/* write(sub1\sub2\aaa22.txt) */
	TestWriteSmallFile("\\sub1\\sub2\\aaa23.txt" );		/* write(sub1\sub2\aaa23.txt) */

	TestWriteSmallFile("\\sub1\\sub2\\sub3\\aaa31.txt" );/* write(sub1\sub2\sub3\aaa31.txt) */
	TestWriteMany("\\sub1\\sub2\\sub3\\bbb", MANY_NUM);	/* 񏑂 */

	TestWriteSmallFile("\\root.txt" );					/* write(root.txt) */
	TestWriteSmallFile("\\sub1\\sub.txt" );				/* write(sub1\sub.txt) */
	TestWriteSmallFile("\\sub1\\sub2\\sub.txt" );		/* write(sub1\sub2\\sub.txt) */
	TestWriteSmallFile("\\sub1\\sub2\\sub3\\sub4\\sub5\\sub5.txt" );/* write(sub1\sub2\\sub.txt) */

	/* move */
	err = RfMove(	"\\sub1\\sub2\\sub3\\sub4\\sub5",
					"\\root.txt" );
	CHK_ERR_CODE(err, RF_OK, "RfMove(root.txt)");
	err = RfMove(	"\\sub1\\sub2\\sub3\\sub4\\sub5",
					"\\sub1\\sub.txt" );
	CHK_ERR_CODE(err, RF_OK, "RfMove(sub1.txt)");
	err = RfMove(	"\\sub1\\sub2\\sub3\\sub4\\sub5",
					"\\sub1\\notexist.txt" );
	CHK_ERR_CODE(err, RF_ERR_NOT_FOUND, "RfMove(notexist.txt[NG])");
	err = RfMove(	"\\sub1\\sub2\\sub3\\sub4\\sub5",
					"\\sub1\\sub2\\sub.txt" );
	CHK_ERR_CODE(err, RF_ERR_ALREADY_EXIST, "RfMove(sub.txt:exist[NG])");
	err = RfMove(	"\\",
					"\\sub1\\sub2\\sub3\\sub4\\sub5\\sub.txt" );
	CHK_ERR_CODE(err, RF_OK, "RfMove(to root)");
	err = RfMove(	"\\sub1\\",
					"\\sub1\\sub2\\sub3\\sub4\\sub5\\root.txt" );
	CHK_ERR_CODE(err, RF_OK, "RfMove(to sub1\\) addend \"\\\".");	
	err = RfMove(	"\\sub1\\sub2\\",
					"\\" );
	CHK_ERR_CODE(err, RF_ERR_ROOT_DIRECTORY, "RfMove(from root[NG])");	/* root͈ړłȂ */

	err = RfMove(	"\\sub1\\sub2\\sub3\\sub4\\sub5",
					"\\sub1" );
	CHK_ERR_CODE(err, RF_ERR_MOVE_POSTERITY, "RfMove(to posterity[NG])");	/* zɂ͈ړłȂ */
	err = RfMove(	"\\sub1\\sub2\\sub3",
					"\\sub1\\sub2\\sub3" );
	CHK_ERR_CODE(err, RF_ERR_MOVE_POSTERITY, "RfMove(to posterity[NG]) case same directory.");	/* zɂ͈ړłȂ */
	err = RfMove(	"\\sub1\\sub2\\",
					"\\sub1\\sub2\\sub3\\sub4\\sub5" );	/* fBNgړ	*/
	CHK_ERR_CODE(err, RF_OK, "RfMove(sub5 to sub2)");
	pFcb = RfOpen( "\\sub1\\sub2\\sub5\\sub5.txt", RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE(err, RF_OK, "open(sub5\\sub5.txt)");
	RfClose(pFcb);
	err = RfMove(	"\\sub1\\sub2\\",
					"\\sub1\\sub2\\sub3\\sub4\\" );	/* fBNgړ \ ̃p^[ */
	CHK_ERR_CODE(err, RF_OK, "RfMove(sub4 to sub2)");

	TestConclude();
	return;
}

