/****************************************************************************/
/* T  vF t@CeXg												*/
/*   F łɃI[vĂt@C̃I[vŃG[ɂȂ邱	*/
/*         ̊mFB															*/
/*          t@CI[v̊mF									*/
/* 쐬F 2011.07.24														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "RfGeneral.h"
#include "TraceOut.h"
#include "TstDefine.h"
#include "TstWriteVal.h"
#include "TstGeneral.h"
#include "TstWriteFunc.h"

/* ֐^錾 */
static void readyEnv( void );
static void TestWrite( void );
static void readMulti01( void );
static void readMulti02(char * pPath);

#define MANY_NUM	(10)

extern const unsigned short rfSameTimeFileNum;

/****************************************************************************/
/* T  v																	*/
/*        t@CI[veXg									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TestMulti( void )
{

	TEST_TITLE(("Test multi file."));
	TestReady();

	readyEnv();
	TestWrite();
	readMulti01();
	readMulti02("\\SUBDIR\\many");

	TestConclude();
}


/****************************************************************************/
/* T  v																	*/
/*        eXg													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void readyEnv( void )
{
	unsigned short err;
	err = RfMkDir("\\SUBDIR");
	CHK_ERR_CODE(err, RF_OK, "mkdir()");
}

/****************************************************************************/
/* T  v																	*/
/*        eXgf[^쐬													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TestWrite( void )
{
	TestWriteLarge( "\\root512.TXT", 512UL );
	TestWriteLarge( "\\root4k.txt", 4096UL+10UL );
	TestWriteLarge( "\\SUBDIR\\SUB512.txt", 512UL );
	TestWriteLarge( "\\SUBDIR\\SUB4K.TXT", 4096UL+10UL );
	TestWriteMany("\\SUBDIR\\many", MANY_NUM);
	
}

/****************************************************************************/
/* T  v																	*/
/*        t@CI[veXg									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        G[P[X														*/
/****************************************************************************/
void readMulti01( void )
{
	unsigned short err = RF_OK;
	int i;

	T_RF_FCB * fcb[2];
	
	fcb[0] = RfOpen("\\root512.TXT",RF_OPEN_READ, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen()");
	fcb[1] = RfOpen("\\root512.TXT",RF_OPEN_READ, &err );
	if( rfSameTimeFileNum > 1 )
	{
		CHK_ERR_CODE(err, RF_ERR_ALREADY_OPEND, "RfOpen()[NG] RF_ERR_ALREADY_OPEND");
	}
	else
	{
		CHK_ERR_CODE(err, RF_ERR_NOT_FREE_FCB, "RfOpen()[NG] RF_ERR_NOT_FREE_FCB");
	}

	for(i = 0; i < 2; i++ )
	{
		if( fcb[i] != NULL )
		{
			err = RfClose(fcb[i]);
			CHK_ERR_CODE(err, RF_OK, "RfClose()");
		}
	}
		
}

/****************************************************************************/
/* T  v																	*/
/*        t@CI[veXg									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        P[X														*/
/****************************************************************************/
void readMulti02( char * pPath )
{
	T_RF_FCB * pFcb[MANY_NUM];
	unsigned short err;
	unsigned long len;
	unsigned short i,j;
	char flName[MANY_NUM][32];
	char readBuff[32];
	unsigned short nameIx;
	unsigned long size =0UL;
	char editBuff[64];

	for( i = 0; pPath[i] != '\0'; ++i )
	{
		for(j = 0; j < MANY_NUM; j++ )
		{
			flName[j][i] = pPath[i];
		}
	}

	nameIx = i;
	for( i = 0; i < MANY_NUM; ++i )
	{
		numToChar( &flName[i][nameIx], (unsigned long)i, 1000L);
		pFcb[i] = RfOpen( flName[i], RF_OPEN_READ, &err );

		rfStrCpy( editBuff, "RfOpen() ", 64);
		rfStrCat( editBuff, flName[i], 64, 16);

		if( rfSameTimeFileNum > i )
		{
			rfStrCat(editBuff, " RF_OK", 64, 16);
			CHK_ERR_CODE(err, RF_OK, editBuff);
		}
		else
		{
			rfStrCat(editBuff, " RF_ERR_NOT_FREE_FCB", 64, 25 );
			CHK_ERR_CODE(err, RF_ERR_NOT_FREE_FCB, editBuff);
		}
	}

	for( i = 0; i < MANY_NUM; i++ )
	{
		if( pFcb[i] )
		{
			err = RfGetSize( pFcb[i], &size );				/* t@CTCY擾@*/
			CHK_ERR_CODE(err, RF_OK, "RfGetSize()");
			CHK_CMP_DEC(size, nameIx + 3, "file Size" );

			len = nameIx + 3;
			err = RfRead( pFcb[i], readBuff, &len);
			if( ( len != 0 ) && ( err == RF_OK ) )
			{
				CHK_CMP_STR(flName[i], readBuff,  "check value.");
			}
			CHK_ERR_CODE(err, RF_OK, "read()");
			err = RfClose( pFcb[i] );
			CHK_ERR_CODE(err, RF_OK, "close()");
		}
	}
	
}

