/****************************************************************************/
/* T  vF READ DIR@\̃eXg											*/
/*   F 																*/
/* 쐬F 2012.08.06														*/
/* XVF 2014.02.08														*/
/* Copyright    resove														*/
/****************************************************************************/
#include "RfInterface.h"
#include "TraceOut.h"
#include "TstWriteVal.h"
#include "TstDefine.h"
#include "TstGeneral.h"

#define SUB_DIR_TEST	(1)				/* TufBNg̃eXgȂ */

/* ̃t@CŎꍇ */
/*#define FILE_NUM		( 20 )
*/
/* 16M ̏ꍇ 16384bytes/clusterBf[^2NX^Ȃ */
/* ̂ 2 NX^ڂɂƂ܂łƂĂ */
#define FILE_NUM_LITTLE		(unsigned short)((512UL*32UL/32UL)*1UL-4UL + 100UL )

/*  2G ̏ꍇ 32768bytes/clusterB 2NX^ */
/*#define FILE_NUM		(unsigned short)((512UL*64UL/32UL)*2UL-4UL)
*/

/*  2G ̏ꍇ 32768bytes/clusterB 1NX^ */
#define FILE_NUM_MANY		(unsigned short)( 512UL*64UL/32UL-4UL )

#define ROOT_COULD_MAKE	(DIR_ROOT_ENTRY_NUM-3)		/* ROOT ɍ쐬łt@C */

static unsigned short fileNum = FILE_NUM_LITTLE;
static unsigned short makeTestData(void);
static unsigned short makeTestDataRoot(void);
static void checkReadDir(void);
static void checkReadDirRoot(void);

/****************************************************************************/
/* T  v																	*/
/*        fBNgǂݎ̃eXg										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void	TestReadDir( void )
{
	T_RF_DRIVE_INFO driveInfo;

	TEST_TITLE(("Test directory read."));
	TestReady();

	RfGetDriveInfo( &driveInfo );
	if( driveInfo.cardSize > 1024UL*1024UL*1024UL )
	{
		fileNum = FILE_NUM_MANY;
	}

	/* [gfBNg̃`FbN */
	if( makeTestDataRoot() == RF_OK )	/* eXgf[^쐬 */
	{
		checkReadDirRoot();			/* `FbN	*/
	}

	/* TufBNg̃`FbN */
#if SUB_DIR_TEST
	if( makeTestData() == RF_OK )	/* eXgf[^쐬 */
	{
		checkReadDir();			/* `FbN	*/
	}
#endif
	TestConclude();

	return;
}

/****************************************************************************/
/* T  v																	*/
/*        eXgf[^(SUB fBNg)								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
unsigned short makeTestData(void)
{
	T_RF_FCB *pFcb;
	unsigned short err = RF_OK;
	unsigned short count;
	char flName[20];
	unsigned long len = 4096UL;

	err = RfMkDir( "\\READDIR" );
	CHK_ERR_CODE(err, RF_OK, "mkdir");
	if( err != RF_OK )							return err;

	/* gq 2 ̃t@C */
	pFcb = RfOpen( "\\READDIR\\RD012345.TX", RF_OPEN_WRITE_NEW, &err );
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfClose( pFcb );
	if( err != RF_OK )							goto ERR_EXIT;

	/* 8+3 ̃t@C */
	pFcb = RfOpen( "\\READDIR\\rd012345.TXT", RF_OPEN_WRITE_NEW, &err );
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfClose( pFcb );
	if( err != RF_OK )							goto ERR_EXIT;


	rfMemCpy(flName, "\\READDIR\\RDxxxx.TXT\0", 20);
	/* t@C */
	for( count = 0; count < fileNum; count++)
	{
		numToChar(&flName[11], (unsigned long)count, 10000); 
		flName[15] = '.';
		pFcb = RfOpen( flName, RF_OPEN_WRITE_NEW, &err );
		if( err != RF_OK )	{				goto ERR_EXIT;}
		err = RfWrite( pFcb, (char*)constWriteVal, &len);
		if( err != RF_OK )	{				goto ERR_EXIT;}
		err = RfClose( pFcb );
		if( err != RF_OK )	{				goto ERR_EXIT;}
		if( (count % 100) == 0 )
		{
			TRACE_OUT(("    make(%04u)\n", count));
		}
	}

ERR_EXIT:
	TRACE_OUT(("    make(%04u)\n", count));
	CHK_ERR_CODE(err, RF_OK, "result of test data making");
	CHK_CMP_DEC(count, fileNum, "Test data making was completed.");
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        eXgf[^(ROOT fBNg)								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
unsigned short makeTestDataRoot(void)
{
	T_RF_FCB *pFcb;
	unsigned short err = RF_OK;
	unsigned short count = 0;
	char flName[20];
	unsigned long len = 4096UL;


	/* gq 2 ̃t@C */
	pFcb = RfOpen( "\\RD012345.TX", RF_OPEN_WRITE_NEW, &err );
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfClose( pFcb );
	if( err != RF_OK )							goto ERR_EXIT;

	/* 8+3 ̃t@C */
	pFcb = RfOpen( "\\RD012345.txt", RF_OPEN_WRITE_NEW, &err );
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfClose( pFcb );
	if( err != RF_OK )							goto ERR_EXIT;


	rfMemCpy(flName, "\\RDxxxx.TXT\0", 20);
	/* t@C */
	for( count = 0; count < ROOT_COULD_MAKE; count++)
	{
		numToChar(&flName[3], (unsigned long)count, 10000); 
		flName[7] = '.';
		pFcb = RfOpen( flName, RF_OPEN_WRITE_NEW, &err );
		if( err != RF_OK )	{				goto ERR_EXIT;}
		err = RfWrite( pFcb, (char*)constWriteVal, &len);
		if( err != RF_OK )	{				goto ERR_EXIT;}
		err = RfClose( pFcb );
		if( err != RF_OK )	{				goto ERR_EXIT;}
		if( (count % 64) == 0 )
		{
			TRACE_OUT(("    make(%04u)\n", count));
		}
	}

ERR_EXIT:
	TRACE_OUT(("    make(%04u)\n", count));
	CHK_ERR_CODE(err, RF_OK, "result of test data making");
	CHK_CMP_DEC(count, ROOT_COULD_MAKE, "Test data making was completed.");
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        TufBNgǂݎ̃eXg									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void checkReadDir(void)
{
	T_RF_FCB *pFcb;
	unsigned short err = RF_OK;
    T_RF_DIR_INFO dirInfo;
    char guide[25];
    char flName[20];
    unsigned short count = 0;
	

	/* fBNg̓ǂݎ */
	pFcb = RfOpenDir( "\\READDIR",  &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpenDir() \"\\READDIR\"");
	if( err != RF_OK )							goto ERR_EXIT;

	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_OK, "RfReadDir");
	if( err != RF_OK )							goto ERR_EXIT;
	CHK_CMP_STR(".", dirInfo.name, "fileName(.)");

	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_OK, "RfReadDir");
	if( err != RF_OK )							goto ERR_EXIT;
	CHK_CMP_STR("..", dirInfo.name, "fileName(..)");

	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_OK, "RD012345.TX");
	if( err != RF_OK )							goto ERR_EXIT;
	CHK_CMP_STR("RD012345.TX", dirInfo.name, "ext 2 char.");

	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_OK, "rd012345.TXT");
	if( err != RF_OK )							goto ERR_EXIT;
	CHK_CMP_STR("rd012345.TXT", dirInfo.name, "8+3 name. body is small letter.");

	rfMemCpy(flName, "RDxxxx.TXT\0", 11); 
	rfMemCpy(guide, "fileName(\0", 10); 
	for( count = 0; count < fileNum; count++ )
	{
		err = RfReadDir(pFcb, &dirInfo);
		if( err != RF_OK )						goto ERR_EXIT;
		numToChar(&flName[2], (unsigned long)count, 10000); 
		flName[6] = '.';
		rfMemCpy(&guide[9], flName, 11); 
		rfMemCpy(&guide[19], ")", 2); 
		if( rfMemCmp(flName, dirInfo.name, 10) != 0 )
		{
			CHK_CMP_STR(flName, dirInfo.name, guide);
			goto ERR_EXIT;
		}
		if( (count % 100) == 0 )
		{
			TRACE_OUT(("    check(%04u)\n", count));
		}
	}

	TRACE_OUT(("    check(%04u)\n", count));
	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_ERR_EOF, "RfReadDir[RF_ERR_EOF]");

ERR_EXIT:
	CHK_CMP_DEC(count, fileNum, "read directory function was completed.");

	if( pFcb != NULL )
	{
		err = RfCloseDir(pFcb);
		CHK_ERR_CODE(err, RF_OK, "RfCloseDir");
	}
}

/****************************************************************************/
/* T  v																	*/
/*        root fBNgǂݎeXg									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void checkReadDirRoot(void)
{
	T_RF_FCB *pFcb;
	unsigned short err = RF_OK;
    T_RF_DIR_INFO dirInfo;
    char guide[25];
    char flName[20];
    unsigned short count;
	

	/* fBNg̓ǂݎ */
	pFcb = RfOpenDir( "\\",  &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpenDir() \"\\\"");
	if( err != RF_OK )							goto ERR_EXIT;

	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_OK, "RfReadDir() \"RD012345.TX\"");
	if( err != RF_OK )							goto ERR_EXIT;
	CHK_CMP_STR("RD012345.TX", dirInfo.name, "ext 2 char.");

	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_OK, "RfReadDir() \"RD012345.txt\"");
	if( err != RF_OK )							goto ERR_EXIT;
	CHK_CMP_STR("RD012345.txt", dirInfo.name, "8+3 name. extension is small letter.");

	rfMemCpy(flName, "RDxxxx.TXT\0", 11); 
	rfMemCpy(guide, "fileName(\0", 10); 
	for( count = 0; count < ROOT_COULD_MAKE; count++ )
	{
		err = RfReadDir(pFcb, &dirInfo);
		if( err != RF_OK )						goto ERR_EXIT;
		numToChar(&flName[2], (unsigned long)count, 10000); 
		flName[6] = '.';
		rfMemCpy(&guide[9], flName, 11); 
		rfMemCpy(&guide[19], ")", 2); 
		if( rfMemCmp(flName, dirInfo.name, 10) != 0 )
		{
			CHK_CMP_STR(flName, dirInfo.name, guide);
			goto ERR_EXIT;
		}
		if( (count % 64) == 0 )
		{
			TRACE_OUT(("    check(%04u)\n", count));
		}
	}

	TRACE_OUT(("    check(%04u)\n", count));
	err = RfReadDir(pFcb, &dirInfo);
	CHK_ERR_CODE(err, RF_ERR_EOF, "RfReadDir[RF_ERR_EOF]");

ERR_EXIT:
	CHK_CMP_DEC(count, ROOT_COULD_MAKE, "read directory function was completed.");

	if( pFcb != NULL )
	{
		err = RfCloseDir(pFcb);
		CHK_ERR_CODE(err, RF_OK, "RfCloseDir");
	}
}
