/****************************************************************************/
/* T  vF SEEK @\̃eXg												*/
/*   F 																*/
/* 쐬F 2011.09.08														*/
/* XVF 2014.02.08														*/
/* Copyright    resove														*/
/****************************************************************************/
#include "RfInterface.h"
#include "TraceOut.h"
#include "TstWriteVal.h"
#include "TstDefine.h"
#include "TstGeneral.h"

static unsigned short writeSpecifyLen(T_RF_FCB * pFcb, unsigned long reqLen);

/****************************************************************************/
/* T  v																	*/
/*        seek ̃eXg														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void	TestSeek( void )
{
	T_RF_FCB *pFcb;
	unsigned short err = RF_OK;
	unsigned long len = 4096L;
	unsigned long size = 0L;
	char readBuff[16];
	

	TEST_TITLE(("Test seek."));
	TestReady();

	err = RfMkDir( "\\SEEKTEST" );
	CHK_ERR_CODE(err, RF_OK, "mkdir");
	if( err != RF_OK )							goto ERR_EXIT;

	/* NX^EɈړeXg*/
	pFcb = RfOpen( "\\SEEKTEST\\SEEK01.TXT", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "open");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfSeek( pFcb, 0L, RF_SEEK_SET);
	CHK_ERR_CODE(err, RF_OK, "seek");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfSeek( pFcb, 16384L, RF_SEEK_SET);	/* 1NX^VȏꏊɈړ */
	CHK_ERR_CODE(err, RF_OK, "seek");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfGetSize( pFcb, &size );
	if( err == RF_OK )
	{
		CHK_CMP_DEC(size, 16384L, "fileSize");
	}
	err = writeSpecifyLen( pFcb, 16384L );		/* 1NX^ */
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfGetSize( pFcb, &size );
	if( err == RF_OK )
	{
		CHK_CMP_DEC(size, 16384L+16384L, "fileSize");
	}
	err = RfSeek( pFcb, 16384L, RF_SEEK_SET);	/* 擪 1NX^Ɉړ */
	CHK_ERR_CODE(err, RF_OK, "seek");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfSeek( pFcb, 16384L, RF_SEEK_CUR);	/* Ō̃NX^EɈړ */
	CHK_ERR_CODE(err, RF_OK, "seek");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfGetSize( pFcb, &size );
	if( err == RF_OK )
	{
		CHK_CMP_DEC(size, 16384L+16384L, "fileSize");
	}
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "close");
	if( err != RF_OK )							goto ERR_EXIT;
	
	len = 512UL;
	pFcb = RfOpen( "\\SEEKTEST\\SEEK02.TXT", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "open");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfSeek( pFcb, 3L, RF_SEEK_SET);
	CHK_ERR_CODE(err, RF_OK, "open");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	CHK_ERR_CODE(err, RF_OK, "write");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfSeek( pFcb, 0L, RF_SEEK_END);
	CHK_ERR_CODE(err, RF_OK, "seek");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "close");
	if( err != RF_OK )							goto ERR_EXIT;

	pFcb = RfOpen( "\\SEEKTEST\\SEEK01.TXT", RF_OPEN_READ, &err );
	CHK_ERR_CODE(err, RF_OK, "open");
	err = RfSeek( pFcb, 16384L*2L, RF_SEEK_SET);	/* ŌɈړ */
	CHK_ERR_CODE(err, RF_OK, "seek");
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfSeek( pFcb, 16384L*2L+1L, RF_SEEK_SET);/* Ōz */
	CHK_ERR_CODE(err, RF_ERR_OUT_OF_LENGTH, "seek error case.");
	
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "close");
	if( err != RF_OK )							goto ERR_EXIT;

	/* read|write RF_OPEN_OPT_SEQ IvV̋L */
	pFcb = RfOpen( "\\SEEKTEST\\SEEK03.TXT", RF_OPEN_READ | RF_OPEN_WRITE_NEW|RF_OPEN_OPT_SEQ, &err );
	CHK_ERR_CODE(err, RF_OK, "open RF_OPEN_OPT_SEQ");
	len = 4096UL;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	CHK_ERR_CODE(err, RF_OK, "write1");
	len = 4096UL;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	CHK_ERR_CODE(err, RF_OK, "write2");
	err = RfSeek( pFcb, 0L, RF_SEEK_SET);	/* 擪ɖ߂ */
	CHK_ERR_CODE(err, RF_OK, "seek to top.");
	len = 16;
	err = RfRead( pFcb, readBuff, &len);
	CHK_ERR_CODE(err, RF_OK, "read");
	CHK_CMP_MEM(readBuff, constWriteVal, 16, "read value.+0(16)");
	err = RfSeek( pFcb, 512L-2L, RF_SEEK_SET);		/* ZN^EɈړ */
	CHK_ERR_CODE(err, RF_OK, "seek to border.");
	len = 2UL;
	err = RfWrite( pFcb, (char*)constWriteVal, &len);
	CHK_ERR_CODE(err, RF_OK, "write3. +510(2)");
	len = 16L;
	err = RfRead( pFcb, readBuff, &len);
	CHK_CMP_MEM(readBuff, &constWriteVal[512], 16, "read value.+512(16)");


	err = RfSeek( pFcb, -16L-2L, RF_SEEK_CUR);		/* ߂ */
	CHK_ERR_CODE(err, RF_OK, "seek to border.");
	len = 2L;
	err = RfRead( pFcb, readBuff, &len);
	CHK_CMP_MEM(readBuff, constWriteVal, 2, "read value. +510(2)");

	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "close");

ERR_EXIT:
	TestConclude();
	return;
}

/****************************************************************************/
/* T  v																	*/
/*        w肵ď												*/
/* p[^																*/
/*        pFcb  Ft@Cʎq											*/
/*        reqLenFޒ												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
unsigned short writeSpecifyLen(T_RF_FCB * pFcb, unsigned long reqLen)
{
	unsigned short err = RF_OK;
	unsigned long len = 0L;

	while( reqLen > 4096L )
	{
		len = 4096L;
		err = RfWrite( pFcb, (char*)constWriteVal, &len);
		CHK_ERR_CODE(err, RF_OK, "write");
		if( err != RF_OK )
		{
			break;
		}
		
		reqLen -= 4096L;
	}

	if( err == RF_OK )
	{
		len = reqLen;
		err = RfWrite( pFcb, (char*)constWriteVal, &len);
		CHK_ERR_CODE(err, RF_OK, "write");
	}

	return err;
}

